var slave_max_num;//=8;
var point_max_num;//=16;//32;
var ret_var = 0;
/*
点表导入提示信息列表
*/
warning_head=["Profile of edge computing exported failed !\n","点表文件导入失败！\n"];
warning_repeat=["Duplicate name!\n","名称重复！\n"];
warning_invalid=["Find invalid parameters in edge computing profile!\n","参数非法！\n"];
warning_length=["the length of this para can not over: ","长度不能超过："];
warning_len_unit=["byte","字符"];
warning_value=["can not over: ","有效值不能大于："];
warning_null = ["must be filled !", "值不能为空！"];
warning_number = ["The number of data points exceeds the maximum range!\n","数据点数量超过最大范围!\n"];
valid_value_range=["the valid value range: ","有效值范围："];
view_valid_value=["value must only be: 'ON' or 'OFF'","有效值只能是：'ON' 或 'OFF'"];
name_repeat=[" have the same name"," 名称重复"];
//slave
s_w_p1=["Slave: ","从机："];
s_w_p2=[" with Slave: "," 与从机："];
//node
n_w_p1=[" Node: "," 数据点："];
/* 
点表文件上传
ca_name：上传的文件名称
url：上传路径
*/
function uploadedge(ca_name,url)
{    
    //var file= new File([JSON.stringify(edgemodel)],'edge.json')
    var file= new Blob([JSON.stringify(edgemodel)])
     form = new FormData(),
     req = new XMLHttpRequest();
     form.append("file", file);
     req.onreadystatechange = function() {
        if(req.readyState === 4 && req.status === 200) {
            console.log('Upload '+ca_name+' OK');
        }
    }
    req.open("post",url, true);
    req.send(form);
    sleep(50);
}
/* 
点表导入：从机、数据点名称查重逻辑
type：查重类型，0：从机  1：数据点
src_name：当前从机名
para：点表导入模板临时json变量
value：查重字符串（从机名或数据点名）
*/
// function csv_value_repeat_check(type,para,value)
function csv_value_repeat_check(type,src_name,para,value)
{
    if(type==0)
    {
        for(var salve_index=0;salve_index<para.ctable.length;salve_index++)
        {
            if(para.ctable[salve_index].name==value)
            {
                alert(warning_head[extention_para.language]+warning_repeat[extention_para.language]+s_w_p1[extention_para.language]+src_name+s_w_p2[extention_para.language]+para.ctable[salve_index].name+name_repeat[extention_para.language]);
                return -1;
            }
        }
    }else if(type==1)
    {
        for(var salve_index=0;salve_index<para.ctable.length;salve_index++)
        {
            for(var point_index=0;point_index<para.ctable[salve_index].datas.length;point_index++)
            {
                if(para.ctable[salve_index].datas[point_index].name==value)
                {
                    alert(warning_head[extention_para.language]+warning_repeat[extention_para.language]+s_w_p1[extention_para.language]+src_name+n_w_p1[extention_para.language]+value+s_w_p2[extention_para.language]+para.ctable[salve_index].name+n_w_p1[extention_para.language]+para.ctable[salve_index].datas[point_index].name+name_repeat[extention_para.language]);
                    return -1;
                }
            }
        }
    }
    return 0;
}
/*
获取点表导入阶段的数据点数据类型
type：数据类型描述字符串
返回数据类型枚举变量值
*/
function get_data_type(type)
{
    var value = -1; //@sgb 20220307 中英文导入点表兼容
    var j = 0;
    for (j = 0; j < 2; j++) { 
    for(var i=0;i<datatype[j].length;i++)
        {
            if(type==datatype[j][i])
            {
                value=i;
                return value;
            }
        }        
    }
    return value;


}
/*
点表导入数据点参数逻辑
s_name:所属从机名
para：点表导入模板临时json变量
point：数据点参数字符串
*/
// function get_csv_point(para,point)
function get_csv_point(s_name,para,point)
{
    var res_value=0;
    if(now_max_node(para)>=256)
    {
        str=["The number of nodes in file of edge computing profile exceeds the limit, the total number of nodes in profile should be: <=256!","边缘计算配置文件导入数据点个数超限，数据点总数应<=256!"]
        alert(warning_head[extention_para.language]+str[extention_para.language]);
        return -1;
    }
    para.ctable[para.ctable.length-1].datas.push(JSON.parse(pointmodel));//ctable添加数据点
    para.rtable.datas.push(JSON.parse(report_point_model));//rtable添加数据点
    /*更新key值*/
    var key=parseInt(para.ctable.length+'0'+(para.ctable[para.ctable.length-1].datas.length>9? para.ctable[para.ctable.length-1].datas.length :'0'+para.ctable[para.ctable.length-1].datas.length));
    para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].key=key;
    para.rtable.datas[para.rtable.datas.length-1].key=key;
    /*更新上报数据点参数*/
    if(edgemodel.rtable.datas.length>0)
    {
        /*继承除变化上报外的上报规则*/
        for(var i=1;i<para.rtable.datas[0].rid.length;i++)
        {
            if(edgemodel.rtable.datas[0].rid[i]<=4)
            {
                para.rtable.datas[para.rtable.datas.length-1].rid.push(edgemodel.rtable.datas[0].rid[i]);
            }
        }
        para.rtable.datas[para.rtable.datas.length-1].sid=edgemodel.rtable.datas[0].sid;
        para.rtable.datas[para.rtable.datas.length-1].fid=edgemodel.rtable.datas[0].fid;
    }
    var public_n_warning=warning_head[extention_para.language]+warning_invalid[extention_para.language]+s_w_p1[extention_para.language];
    var splits=point.split(',');
    if(splits[7]!='')/*数据点名称*/
    {
        // if(para.ctable[para.ctable.length-1].datas.length>1)
        if (splits[7].length > 16)
        { 
            str = ["include  a node names whose length is greater than 16!","有数据点名称长度大于16！"];
            alert(warning_head[extention_para.language]+warning_invalid[extention_para.language]+s_w_p1[extention_para.language]+s_name+str[extention_para.language]);
            return -1;
        }
        if(get_max_node(para)<=256)
        {
            //if(csv_value_repeat_check(1,para,splits[7])==-1)/*数据点名称查重*/
            if(csv_value_repeat_check(1,s_name,para,splits[7])==-1)/*数据点名称查重*/
            {
                return -1;
            }else{
                /*数据点名称*/
                para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].name=splits[7];
                para.rtable.datas[para.rtable.datas.length-1].name=splits[7];
            }
        }
    }else{
        str=[" include a node whose name is null!","有数据点名称为空！"];
        alert(warning_head[extention_para.language]+warning_invalid[extention_para.language]+s_w_p1[extention_para.language]+s_name+str[extention_para.language]);
        return -1;
    }
    if(splits[8]!=''&&splits[9]!='')/*数据点功能码、寄存器地址*/
    {
        var value=parseInt(splits[9])+1+'';
        var value_str='';
        var value_cmd;
        str1=[" and "," 且 " ];
        if(splits[8]>4||splits[8]<1)
        {
            str=["'Function code err! ","的功能码存在错误，"];
            alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]+valid_value_range[extention_para.language]+"≥"+1+str1[extention_para.language]+"≤"+4);
            return -1;
        }
        if(splits[9]<0||splits[9]>65534)
        {
            str=["'Register address err! ","的寄存器地址存在错误，"];
            alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]+valid_value_range[extention_para.language]+"≥"+0+str1[extention_para.language]+"≤"+65534);
            return -1;
        }
        for(var i=value.length;i<4;i++)
        {
            value_str+='0';
        }
        if(splits[8]==3)
        {
            value_cmd='4';
        }else{
            value_cmd=parseInt(splits[8])-1+'';
        }
        var test=value_cmd+value_str+value;
        para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].addr=value_cmd+value_str+value;
    }else{
        if(splits[8]=='')
        {
            str=["'Function code is null !","的功能码参数为空！"]
            alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]);
            return -1;
        }
        if(splits[9]=='')
        {
            str=["'Register address is null !","的寄存器地址参数为空！"]
            alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]);
            return -1;
        }
    }
    if(splits[10]!='')
    {
        var type=get_data_type(splits[10]);
        if(type!=-1)
        {
            para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].type=type;/*数据类型*/
        }else{
            str=[" includes an invalid Data type!","的数据类型不存在！"];
            alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]);
            return -1;
        }
    }else{
        str=["'Data type is null!","的数据类型参数为空！"];
        alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]);
        return -1;
    }
    para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].ct=para.ctable[para.ctable.length-1].ct;/*轮询间隔，依赖从机轮询间隔*/
    if(splits[11]!='')
    {
        if(splits[11]>65535||splits[11]<10)
        {
            str=["'Timeout is err!","的超时时间参数存在错误！"];
            str1=[" and "," 且 " ];
            alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]+valid_value_range[extention_para.language]+"≥"+10+str1[extention_para.language]+"≤"+65535);
            return -1;
        }
        para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].to=parseInt(splits[11]);/*超时时间*/
    }else{
        str=["'parameters of Timeout is null!","的超时时间为空！"];
        alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]);
        return -1;
    }
    /*变化范围上报*/
    if(splits[12]!='')
    {
        if(splits[12]=='on'||splits[12]=='ON')/*变化上报开启*/
        {
            para.rtable.rules.push(JSON.parse('{"type":3,"change":0}'));//增加上报表规则
            para.rtable.datas[para.rtable.datas.length-1].rid.push(para.rtable.rules.length);//增加该点上报rid
        }else if(splits[12]=='off'||splits[12]=='OFF'){/*变化上报关闭*/
            ;
        }else{
            str=["'Reporting on change is err! "," 变化上报"];
            alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]+view_valid_value[extention_para.language]);
            return -1;
        }
    }else{
        str=["'parameters of Reporting on change is null!","的变化上报参数为空！"];
        alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]);
        return -1;
    }
    if(splits[13]!='')
    {
        if(0<=parseInt(splits[13])&&parseInt(splits[13])<=65535)
        {
            if(para.rtable.rules[para.rtable.datas[para.rtable.datas.length-1].rid[para.rtable.datas[para.rtable.datas.length-1].rid.length-1]-1].type==3&&
            'change' in para.rtable.rules[para.rtable.datas[para.rtable.datas.length-1].rid[para.rtable.datas[para.rtable.datas.length-1].rid.length-1]-1])//数据点对应rule确认
            {
                //if(splits[12]=='on'||splits[12]=='ON')
                {
                    para.rtable.rules[para.rtable.datas[para.rtable.datas.length-1].rid[para.rtable.datas[para.rtable.datas.length-1].rid.length-1]-1].change=splits[13];
                }
            }else{
                console.log("report type of change check is err");//debuug
            }
        }else{
            if(splits[12]=='on'||splits[12]=='ON')
            {
                str=["'Variation range is err!","的变化范围参数错误！"];
                str1=[" and "," 且 " ];
                alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]+valid_value_range[extention_para.language]+"≥"+0+str1[extention_para.language]+"≤"+65535);
                return -1;
            }
        }
    }else{
        if(splits[12]=='on'||splits[12]=='ON')
        {
            str=["'parameters of Variation range is null!","的变化范围参数为空！"];
            alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]);
            return -1;
        }
    }
    if(splits[14]!='')
    {
        if(splits[14]!='N/A')
        {
            if(0<=parseInt(splits[14])&&parseInt(splits[14])<=65534)
            {
                para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].maddr=parseInt(splits[14]);/*映射地址*/
            }else{
                str=["'Map node address is err!","的数据点映射地址错误！"];
                str1=[" and "," 且 " ];
                alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]+valid_value_range[extention_para.language]+"≥"+0+str1[extention_para.language]+"≤"+65534);
                return -1;
            }
        }else
        {
            delete para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].maddr;
        }
    }else{
        str=["'parameters of Map node address is null!","的映射数据点地址为空！"];
        alert(public_n_warning+s_name+n_w_p1[extention_para.language]+splits[7]+str[extention_para.language]);
        return -1;
    }
    if(splits[15]!='')
    {
        para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].form=splits[15];/*计算公式*/
    }else{
        delete para.ctable[para.ctable.length-1].datas[para.ctable[para.ctable.length-1].datas.length-1].form;
    }
    return res_value;
}
/*深拷贝*/
function deepClone(obj) {
    let _obj = JSON.stringify(obj),
          objClone = JSON.parse(_obj);
      return objClone
  }
/*
点表导入从机参数逻辑
*/
// const ctablemodel='{"ctable":[]}';
const ctablemodel='{"ctable":[]}';
function csv_2_json(src)
{
    var slave_name='';
    var point_name;
    var src_value = src.split(/\s+/);

    var csv_in=JSON.parse(ctablemodel);
    /*原上报表参数存储处理*/
    // csv_in.rtable=edgemodel.rtable;//上报表copy
    csv_in.rtable=deepClone(edgemodel.rtable);//上报表copy
    /*移除上报表内的变化上报规则*/
    for(var i=0;i<csv_in.rtable.rules.length;i++)
    {
        if(csv_in.rtable.rules[i].type==3)
        {
            csv_in.rtable.rules.splice(i,1);
        }
    }
    /*移除上报表所有数据点*/
    csv_in.rtable.datas=JSON.parse('{"datas":[]}').datas;
    if(csv_in.rtable.datas.length!=0)//移除成功确认
    {
        console.log("remove datas of rtable err!");
    }
     if (src_value.length > 130) { 
        alert(warning_head[extention_para.language]+warning_number[extention_para.language]);
        return -1;
    }   
    /*导入逻辑开始*/
    if(src_value.length>1)
    {
        for(var point_index=1;point_index<src_value.length;point_index++)
        {
            var splits=src_value[point_index].split(',');
            if(slave_name==splits[0])/*存储从机下的数据点参数*/
            {
                // if(get_csv_point(csv_in,src_value[point_index])==-1)/*保存数据点*/
                if(get_csv_point(splits[0],csv_in,src_value[point_index])==-1)/*保存数据点*/
                {
                    return -1;
                }
            }else{/*存储从机参数*/
                var public_s_warning=warning_head[extention_para.language]+warning_invalid[extention_para.language]+s_w_p1[extention_para.language];
                if(splits[0]!='')
                {
                    if(csv_value_repeat_check(0,splits[0],csv_in,splits[0]))/*从机名称查重*/
                    {
                        return-1;
                    }
                    if(splits[0].length>16)/*从机名称长度检查*/
                    {
                        str=["'Name is err!"," 名称"];
                        alert(public_s_warning+splits[0]+str[extention_para.language]+warning_length[extention_para.language]+16+warning_len_unit[extention_para.language]);
                        return -1;
                    }
                    csv_in.ctable.push(JSON.parse(slavemodel));
                    csv_in.ctable[csv_in.ctable.length-1].key=csv_in.ctable.length;
                    csv_in.ctable[csv_in.ctable.length-1].name=splits[0];/*从机名称*/
                }else{
                    break;
                }
                if(splits[1]!='')
                {
                    if(splits[1]>extention_para.portmax)/*端口值检查*/
                    {
                        str=["'Port is err!"," 端口号"];
                        alert(public_s_warning+splits[0]+str[extention_para.language]+warning_value[extention_para.language]+extention_para.portmax);
                        return -1;
                    }
                    csv_in.ctable[csv_in.ctable.length-1].port[1]=parseInt(splits[1]);/*从机端口*/
                }else{
                    str=["'Port is err!"," 端口号"];
                    alert(public_s_warning+splits[0]+str[extention_para.language]+warning_null[extention_para.language]);
                    return -1;
                }
                if(splits[2]!='')
                {
                    if(splits[2]>=1&&splits[2]<=255)
                    {
                        csv_in.ctable[csv_in.ctable.length-1].port[2]=parseInt(splits[2]);/*从机地址*/
                    }else{
                        str=["'Slave Address is err!"," 从机地址"];
                        str1=[" and "," 且 " ];
                        alert(public_s_warning+splits[0]+str[extention_para.language]+valid_value_range[extention_para.language]+"≥"+1+str1[extention_para.language]+"≤"+255);
                        return -1;
                    }
                }else{
                    str=["'Slave Address is err!"," 从机地址"];
                    alert(public_s_warning+splits[0]+str[extention_para.language]+warning_null[extention_para.language]);
                    return -1;
                }
                if(splits[3]!='')
                {
                    if(splits[3]>=10&&splits[3]<=65535)
                    {
                        csv_in.ctable[csv_in.ctable.length-1].ct=parseInt(splits[3]);/*轮询间隔*/
                    }else{
                        str=["'Polling interval is err! "," 轮询间隔"];
                        str1=[" and "," 且 " ];
                        alert(public_s_warning+splits[0]+str[extention_para.language]+valid_value_range[extention_para.language]+"≥"+10+str1[extention_para.language]+"≤"+65535);
                        return -1;
                    }
                }else{
                    str=["'Polling interval is err! "," 轮询间隔"];
                    alert(public_s_warning+splits[0]+str[extention_para.language]+warning_null[extention_para.language]);
                    return -1;
                }
                if(splits[4]!='')
                {
                    if(splits[4]!='N/A')
                    {
                        str=["'Map Slave address is err! "," 映射地址"];
                        str1=[" and "," 且 " ];
                        if(0<=parseInt(splits[4])&&parseInt(splits[4])<=255/*65535*/)
                        {
                            csv_in.ctable[csv_in.ctable.length-1].maddr=parseInt(splits[4]);/*映射地址*/
                        }else{
                            alert(public_s_warning+splits[0]+str[extention_para.language]+valid_value_range[extention_para.language]+"≥"+10+str1[extention_para.language]+"≤"+65535);
                            return -1;
                        }
                    }else
                    {
                        delete csv_in.ctable[csv_in.ctable.length-1].maddr;
                    }
                }else{
                    str=["'Map Slave address is err! "," 映射地址"];
                    alert(public_s_warning+splits[0]+str[extention_para.language]+warning_null[extention_para.language]);
                    return -1;
                }
                if(splits[5]!='')
                {
                    if(splits[5]=='on'||splits[5]=='ON')
                    {
                        csv_in.ctable[csv_in.ctable.length-1].group=1;/*合并采集开启*/
                    }else if(splits[5]=='off'||splits[5]=='OFF'){
                        csv_in.ctable[csv_in.ctable.length-1].group=0;/*合并采集关闭*/
                    }else{
                        str=["'Merge collection is err! "," 合并采集"];
                        alert(public_s_warning+splits[0]+str[extention_para.language]+view_valid_value[extention_para.language]);
                        return -1;
                    }
                }else{
                    str=["'Merge collection is err! "," 合并采集"];
                    alert(public_s_warning+splits[0]+str[extention_para.language]+warning_null[extention_para.language]);
                    return -1;
                }
                // if(get_csv_point(csv_in,src_value[point_index])==-1)/*保存数据点*/
                if(get_csv_point(splits[0],csv_in,src_value[point_index])==-1)/*保存数据点*/
                {
                    return-1;
                }
                slave_name=splits[0];
            }
        }
        if(csv_in.ctable.length>=1)
        {
            delete edgemodel.ctable;
            edgemodel.ctable=csv_in.ctable;
            delete edgemodel.rtable;
            edgemodel.rtable=csv_in.rtable;
            loadgather();/*重新加载采集配置*/
            return 0;
        }
    }
}
/**
 * 导出csv模板
 */
function csvin()
{
    var err_str='Upload err ! Confirm file attributes!';
    var time = 0;
    if(!Array.prototype.indexOf)
    {
        Array.prototype.indexOf=function(obj,start){
        for(var index=(start || 0), j=this.length;index<j;index++){
            if(this[index]===obj){ 
            return index; 
            }
        }
        return -1;
        }
    }
    var file = document.getElementById("image").files[0];

    if(file!=null)
    {
        // if(file.size<=1024*32)
        // {
            var reader = new FileReader();
            reader.onload = function fileReadCompleted(){
                //console.log(reader.result);
                var src_value = reader.result.split(/\s+/);
                var splits = src_value[0].split(',');
                if (((splits[0] != "设备名称") && (splits[0] != "Device-name")) && (time == 0)) {
                     time = 1;                   
                    reader.readAsText(file, 'utf-8');
                }
                else if (((splits[0] != "设备名称") && (splits[0] != "Device-name")) && (time == 1))
                { 
                    alert(err_str);
                }
                else { 
                    if(ret_var = csv_2_json(reader.result)!=0)
                    {
                        //result=["Import file of edge computing's Data Acquisition failed",'边缘计算数据采集配置文件导入失败'];
                        //alert(result[extention_para.language]);
                    }else{
                        view_max_node(edgemodel);
                        return;
                    }                    
                }
        }

        reader.readAsText(file, 'gbk');

    }else{
        alert('NO file is selected!');
    }
}
/* 
 * 导出csv模板
*/
const csvh=["Device-name,Port-number,Slave-address,Polling-interval,Mapped-address,Merge-collection,,Node-name,Function-code,Register-Address,Data-type,Response-Timeout,Reporting-on-change,Variation-range,Mapped-address,Formula\n",
"设备名称,串口号,从机地址,轮询间隔,映射地址,合并采集,,数据点名称,功能码,寄存器地址,数据类型,超时时间,变化上报,变化范围,映射地址,数据计算\n"]
var cr='\n';
function csvout()
{
    var data =csvh[extention_para.language];
    /*slave*/
    for(var i=0;i<edgemodel.ctable.length;i++)
    {
        /*point*/
        for(j=0;j<edgemodel.ctable[i].datas.length;j++)
        {
            /*slave*/
            data+=edgemodel.ctable[i].name+',';
            data+=edgemodel.ctable[i].port[1]+',';
            data+=edgemodel.ctable[i].port[2]+',';
            data+=edgemodel.ctable[i].ct+',';
            if('maddr' in edgemodel.ctable[i])
            {
                data+=edgemodel.ctable[i].maddr+',';
            }else{
                data+='N/A'+',';
            }
            if(edgemodel.ctable[i].group==0)
            {
                data+='OFF'+','+',';
            }else{
                data+='ON'+','+',';
            }
            /*point*/
            data+=edgemodel.ctable[i].datas[j].name+',';/*数据点名称*/
            var addr=edgemodel.ctable[i].datas[j].addr;
            if(addr[0]==4)
            {
                data+=3+',';
            }else{
                data+=(parseInt(addr[0])+1)+',';
            }
            data+=(parseInt(addr.slice(1))-1)+',';/*寄存器地址*/
            data+=datatype[extention_para.language][edgemodel.ctable[i].datas[j].type]+',';/*数据类型*/
            data+=edgemodel.ctable[i].datas[j].to+',';/*超时时间*/
            /*数据点变化上报参数*/
            var rid=0;
            if('datas' in edgemodel.rtable)
            {
                for(var num=0;num<edgemodel.rtable.datas.length;num++)
                {
                    if(edgemodel.ctable[i].datas[j].key==edgemodel.rtable.datas[num].key)
                    {
                        for(var r=0;r<edgemodel.rtable.datas[num].rid.length;r++)
                        {
                            if(edgemodel.rtable.datas[num].rid[r]>4)/*该数据点存在变化上报规则*/
                            {
                                rid=edgemodel.rtable.datas[num].rid[r];
                                break;
                            }
                        }
                    }
                    if(rid!=0)
                    {
                        break;
                    }
                }
            }
            if(rid!=0)
            {
                data+='ON'+',';/*数据点变化范围上报开启*/
                if(edgemodel.rtable.rules.length+1>=rid&&edgemodel.rtable.rules[rid-1].type==3)
                {
                    data+=edgemodel.rtable.rules[rid-1].change+',';
                }else{
                    data+=',';
                }
            }else{
                data+='OFF'+',';
                data+=',';
            }
            if('maddr' in edgemodel.ctable[i].datas[j])
            {
                data+=edgemodel.ctable[i].datas[j].maddr+',';/*映射地址*/
            }else{
                data+='N/A'+',';
            }
            if('form' in edgemodel.ctable[i].datas[j])
            {
                data+=edgemodel.ctable[i].datas[j].form+cr;/*数据公式*/
            }else{
                data+=','+cr;
            }
        }
    }
    var blob;
    var fileName;
    var csvData = data;
    if(extention_para.language==0)
    {
        fileName = "edge-EN.csv";
        blob = new Blob([ csvData ], {
        type : "application/csv;charset=utf-8;"
        });
    }
    else if (extention_para.language == 1)
    {
        fileName = "edge-CN.csv";
        blob = new Blob([ csvData ], {
        type : "application/csv;charset=gbk;"
        });
    } 
    
    if (window.navigator.msSaveBlob) {
    // FOR IE BROWSER
    navigator.msSaveBlob(blob, fileName);
    } else {
    // FOR OTHER BROWSERS
    var link = document.createElement("a");
    var csvUrl = URL.createObjectURL(blob);
    link.href = csvUrl;
    link.style = "visibility:hidden";
    link.download = fileName;
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    }
}
/* 
type: 0:网页加载过程 1:模式改变过程
*/
function loadtabcontrol(name,num,type)
{
    if(type==0)
    {
        document.getElementById(name).value=econfig[name];
    }
    tabcontrol(name,num);
    if(type==1)
    {
        if(document.getElementById(name).value==1)
        {
            var sta=extention_para.edge_usr_sta.split(',');
            if(sta[0]==1)
            {
                info=["The function of edge computing is mutually exclusive with the function of the USR Cloud's edge computing. if the edge computing function is Enabled, the function of the USR Cloud's edge computing will be Disabled automatically","边缘计算网关功能与有人云边缘计算功能互斥，配置边缘计算网关功能开启后，有人云边缘计算功能会自动关闭"];
                alert(info[extention_para.language]);
            }
        }
    }
}
/* 
从机列表加载
*/
function loadgather()
{
    var f=document.edge;
    var senname;
    cleartable('slavetbody');
    slaveindex=0;
    slavename=[];
    for(var sindex=0;sindex<edgemodel.ctable.length;sindex++)
    {
        addslaver(0);
    }
    if(edgemodel.ctable.length!=0)
    {
        selectslaver(1,'slavet1',0)
    }else{/*若无从机，数据点列表亦清空*/
        var tb=document.getElementById('pointtbody');
        var tr=tb.getElementsByTagName("tr");
        if(tr.length>=0)
        {
            var length=tr.length;
            for(var i=0;i<length;i++)
            {
                tb.removeChild(tr[0]);
            }
        }
    }
}
/* 
数据点列表加载
*/
function loadpointable(sindex)
{
    cleartable('pointtbody');
    pointindex=0;
    pointname=[];
    for(var i=0;i<edgemodel.ctable[sindex].datas.length;i++)
    {
        addpoint(sindex,0);
    }
}
/*列表项选择 
type:0 slave, 1 point
*/
function autoselecttable(type)
{
    if(type==0)
    {
        var tb=document.getElementById('slavetbody');
    }else if(type==1)
    {
        tb=document.getElementById('pointtbody');
    }
    var tr=tb.getElementsByTagName('tr');
    for(var i=0;i<tr.length;i++)
    {
        if(gethexcolor(tr[i].id)=='#0054a4')
        {
            document.getElementById(tr[i].id).style.background='#ffffff';
        }
    }
}
/*列表项选中
执行动作：
1、选中项'高亮'
2、加载该从机从属数据点
*/
var slaveselectedindex;
var button_flag=0;
function selectslaver(selectedindex,id,type)
{
    // button_flag=1;
    // if(button_flag)
    // {
        if(gethexcolor(id)=='#ffffff')
        {   
            autoselecttable(type);
            document.getElementById(id).style.background='#0054a4';
            var tr=document.getElementById(id);
            var td=tr.getElementsByTagName('td');
            var name=td[1].innerHTML;
            var sindex=serchindex(0,name)
            slaveselectedindex=sindex;
            loadpointable(sindex);
        }else
        {
            document.getElementById(id).style.background='#ffffff';
            if(edgemodel.ctable.length!=0)
            {
                selectslaver(1,'slavet1',0)
            }
        }
        // button_flag=0;
    // }
    if(button_flag)
    {
        button_state_deal(0,true);//临时-debug
    }
}
/* */
const edit_dele=[['Edit','Delete'],['编辑','删除']];
const save_cancel=[['Save','Cancel'],['保存','取消']];
/* */
const helpstr=[
['Device name: The name of the slave device cannot be Chinese character, and the name of the slaves cannot be same',
'Must fill in the item',
'Duplicate slave name',
'Duplicate node name',
"The model file of Edge Computing's Data Acquisition can be exported by button of 'Export...'",
"Variation range: Reporting when the change of two collected data values greater than the set range, 0~65535.",
"Regular time: \nReporting each hour. it will report at 00:00, 01:00, 02:00...\nReporting every quarter. it will report at 00:00, 00:15, 00:30...\nReporting every minute.  it will report at 00:01, 00:02, 00:03...\nReporting at fixed time.it will report at a fixed time every day.",
"If the polling fails, the corresponding data point will be filled with the specified string.",
'Json template:\n{\n    "device01":{\n         "Current":"node0101",\n         "Voltage":"node0102"\n    },\n    "device02":{\n         "Temperature":"node0201",\n         "Humidity":"node0202"\n    }\n}',
"Create a virtual address for this device. The gateway uses the physical address to collect the device data, and the server access the collected data via the virtual address.\nNote: Server can directly access the collected data through the physical address if disable address mapping function. ",
"Data query and report methods, supports TCP, UDP, HTTP, MQTT, Alibaba cloud and AWS IoT. Enable and configure the corresponding socket before selecting it.",
"The collected data will be calculated by the formular and then uploaded. '%s' in the formular is the original collected data.\nFor example, collected value plus 10: =%s+10 ",
"The number of nodes allowed to be added. "
],
["设备名称：当前配置从机名称，不可为中文，从机名不可重复",
"有必须填充项为空",
"从机名称重复",
"数据点名称重复",
"边缘计算的数据采集功能配置模板可通过 '配置导出' 按钮导出",
"变化范围:当两次采集数值大于设置变化范围时上报.设置范围0~65535.",
"上报时间:\n整小时上报：则00：00、01：00、02：00...上报\n整刻钟上报：则00：00、00：15、00：30...上报\n整分钟上报：则00：01、00：02、00：03...上报\n固定时间上报：则在每天的固定时间上报",
"寄存器轮询失败后对应的数据点会填充为指定字符串。",
'Json 模板:\n{\n    "device01":{\n         "Current":"node0101",\n         "Voltage":"node0102"\n    },\n    "device02":{\n         "Temperature":"node0201",\n         "Humidity":"node0202"\n    }\n}',
"给此设备创建一个虚拟地址，网关通过物理地址采集设备数据，服务器可通过虚拟地址访问被采集到的数据。\n注:非映射模式服务器可直接通过物理地址访问被采集到的数据。",
"数据查询和数据上报方式，可选择TCP、UDP、HTTP、MQTT、阿里云、AWS等方式。通道使用之前需要先开启并配置，例如通过MQTT上报需要先开启MQTT功能并配置基本接入参数。",
"设备采集数据经公式计算后上传，公式中的%s为原始采集数据。\n如，采集值加10：=%s+10",
"当前还允许添加的数据点数量。"]
];
function helpwindow(index)
{
    alert(helpstr[extention_para.language][index]);
}
/*
页面添加、编辑从机、数据点名称查重
*/
function valuerepeat(index,mode)
{
    var res=1;
    var f=document.edge;
    if(mode==0)
    {
        for(j=0;j<slavename.length;j++)
        {
            if(slavename[j]==f.s1v.value&&slavename[index-1]!=f.s1v.value)
            {
                helpwindow(2);
                res=0;
                break;
            }
        }
    }else if(mode==1)
    {
        // for(j=0;j<pointname.length;j++)
        // {
        //     if(pointname[j]==f.p1v.value)
        //     {
        //         helpwindow(3);
        //         res=0;
        //     }
        // }
        for(j=0;j<edgemodel.ctable.length;j++)
        {
            for(var i=0;i<edgemodel.ctable[j].datas.length;i++)
            {
                if(edgemodel.ctable[j].datas[i].name==f.p1v.value&&pointname[index-1]!=f.p1v.value)
                {
                    helpwindow(3);
                    res=0;
                    break;
                }
            }
        }
    }
    return res;
}
/*编辑界面固定参数非空判断
mode:0 slave
mode:1 point
num:固定参数配置项数量
*/
function checkcontentnull(mode,num)
{
    var contentname;
    var res=1;
    if(mode==0)
    {
        contentname='s';
    }else{
        contentname='p';
    }
    for(var i=1;i<num+1;i++)
    {
        if(document.getElementById(contentname+i+'v').type=='text'||document.getElementById(contentname+i+'v').type=='number')
        {
            if(document.getElementById(contentname+i+'v').value=='')
            {
                helpwindow(1);
                res=0;
                break;
            }
        }else if(document.getElementById(contentname+i+'v').type=='select-one')
        {

        }else if(document.getElementById(contentname+i+'v').type=='checkbox')
        {
            var index=i+1;
            if(index>num){
                break;
            }
            if(document.getElementById(contentname+index+'v').type=='text')
            {
                if(document.getElementById(contentname+i+'v').checked)
                {
                    if(document.getElementById(contentname+index+'v').value=='')
                    {
                        helpwindow(1);
                        res=0;
                        break;
                    }
                }
                i=index;
            }
        }
    }
    return res;
}
/*
获取允许存储的数据点个数
model:当前点表数据json文件
*/
function get_max_node(model)
{
    // var model_file_max_size=1024*45+820;
    // var slave_max_size=120;
    // var node_max_size=180;
    // var model_file_now=JSON.stringify(model);
    // var max_node=Math.floor((model_file_max_size-model_file_now.length)/node_max_size);
    // return (max_node>1?max_node-1:0);
    var max_node_num=128;//256;
    if('ctable' in model)
    {
        var node_num_crr=0;
        for(var s_num=0;s_num<model.ctable.length;s_num++)
        {
            if('datas' in model.ctable[s_num])
            {
                node_num_crr+=model.ctable[s_num].datas.length;
            }
        }
        return (max_node_num>=node_num_crr?max_node_num-node_num_crr:0);
    }else{
        return max_node_num;
    }
}
/*
获取当前数据点个数
*/
function now_max_node(model)
{
    if('ctable' in model)
    {
        var node_num_crr=0;
        for(var s_num=0;s_num<model.ctable.length;s_num++)
        {
            if('datas' in model.ctable[s_num])
            {
                node_num_crr+=model.ctable[s_num].datas.length;
            }
        }
        return node_num_crr;
    }
}
/*
数据点添加显示逻辑
model：当前边缘计算json点表
*/
function view_max_node(model)
{
    node_num_wh=['last: ','剩余：'];
    node_num_wt=[' nodes','个数据点'];
    document.getElementById('node_nums').innerText=node_num_wh[extention_para.language]+get_max_node(model)+node_num_wt[extention_para.language];//'('+get_max_node(model)+' nodes'+')';//'(<'+get_max_node(model)+' nodes'+')';
    //document.getElementById('node_nums_img').style.display='block';
}
/*
按键互斥逻辑
type: 类型，0：salve edit 1：point edit
state: 其他按键状态 true:禁用 ；false:使能
*/
function button_state_deal(type,state)
{
  button_name=[['save_slave_button','cancel_slave_button'],['save_point_button','cancel_point_button']];
  var name=document.getElementById("econfig");
  var t1 = name.getElementsByTagName("input");
  for(i=0;i<t1.length;i++)
  {
    if(t1[i].type == "button")
    {
      if(t1[i].id!=button_name[type][0]&&t1[i].id!=button_name[type][1])
      {
        t1[i].disabled = state;
      }
    }else if(t1[i].type == "submit")
    {
        t1[i].disabled = state;
    }
  }
}
/*根据名称返回从机或数据点在点表的Index
mode:0,slave
mode:1,point
name:从机或数据点名称
*/
function serchindex(mode,name)
{
    slave_max_num=edgemodel.ctable.length;
    for(var sindex=0;sindex<slave_max_num;sindex++)
    {
        if(edgemodel.ctable[sindex].name==name)
        {
            if(mode==0)
            {
                return sindex;
            }
        }
        if(mode==1)
        {
            point_max_num=edgemodel.ctable[sindex].datas.length;
            for(var pindex=0;pindex<point_max_num;pindex++)
            {
                if(edgemodel.ctable[sindex].datas[pindex].name==name)
                {
                    return  pindex;
                }
            }
        }
    }
}
/*从机列表参数加载
index:从机列表标签
sindex:从机点表标签
*/
port_index=['Port','串口'];
function loadslavetable(index,sindex)
{
    var tr=document.getElementById('slavet'+index);
    var td=tr.getElementsByTagName('td');
    td[1].innerHTML=edgemodel.ctable[sindex].name;
    td[2].innerHTML=/*'串口'*/port_index[extention_para.language]+edgemodel.ctable[sindex].port[1];/*从机设备端口号*/
    td[3].innerHTML=edgemodel.ctable[sindex].port[2];/*从机地址*/
}
/*记录从机名*/
var slavename=[];
/*从机参数保存模板*/
const slavemodel='{"key":0,"name":"","prot":"mbrtu","port":["uart",0,0],"group":0,"maddr":0,"ct":0,"datas":[]}';
/*从机编辑界面保存*/
function saveslave(index,mode)
{
    var sindex;
    var ctl = 0; //key值
    var sln = 0; //设备数量遍历
    var f=document.edge;
    var state,para_num=6;
    if(f.s6v.checked)
    {
        para_num=7;
    }
    state=checkcontentnull(0,para_num);
    if(state==1)
    {
        if(mode==1)/*添加保存*/
        {
            if(valuerepeat(index,0)==0)
            {
                return;
            }
            edgemodel.ctable.push(JSON.parse(slavemodel));
            sindex=edgemodel.ctable.length-1;
            //edgemodel.ctable[sindex].key = edgemodel.ctable.length;  
            edgemodel.ctable[sindex].key = 0;
            while (edgemodel.ctable[sindex].key == 0)
            { 
                ctl+=1;
                for (sln = 0; sln < edgemodel.ctable.length; sln++)
                { 
                    if (edgemodel.ctable[sln].key == ctl) { 
                        break;
                    }       
                    if (sln == edgemodel.ctable.length-1) { 
                        edgemodel.ctable[sindex].key = ctl;
                    }                    
                }                    
            }
            edgemodel.ctable[sindex].name=f.s1v.value;
            edgemodel.ctable[sindex].port[1]=parseInt(f.s2v.value);
            edgemodel.ctable[sindex].port[2]=parseInt(f.s3v.value);
            edgemodel.ctable[sindex].ct=parseInt(f.s4v.value);
            if(edgemodel.ctable[sindex].datas.length)
            {
                for(var num=0;num<edgemodel.ctable[sindex].datas.length;num++)
                {
                    edgemodel.ctable[sindex].datas[num].ct=edgemodel.ctable[sindex].ct;
                }
            }
            if(f.s6v.checked)
            {
                edgemodel.ctable[sindex].maddr=parseInt(f.s7v.value);
            }else{
                delete edgemodel.ctable[sindex].maddr;
            }
            if(f.s8v.checked)
            {
                edgemodel.ctable[sindex].group=1;
            }else{
                edgemodel.ctable[sindex].group=0;
            }
            addslaver(mode);
            index=slaveindex;
        }else if(mode==2)/*编辑保存*/
        {
            sindex=serchindex(0,slavename[index-1]);
            if(valuerepeat(index,0)==0)
            {
                return;
            }//从机名编辑查重
            slavename[index-1]=f.s1v.value;/*更新缓存从机名称*/
            edgemodel.ctable[sindex].name=f.s1v.value;
            edgemodel.ctable[sindex].port[1]=parseInt(f.s2v.value);
            edgemodel.ctable[sindex].port[2]=parseInt(f.s3v.value);
            edgemodel.ctable[sindex].ct=parseInt(f.s4v.value);
            if(edgemodel.ctable[sindex].datas.length)
            {
                for(var num=0;num<edgemodel.ctable[sindex].datas.length;num++)
                {
                    edgemodel.ctable[sindex].datas[num].ct=edgemodel.ctable[sindex].ct;
                }
            }
            if(f.s6v.checked)
            {
                edgemodel.ctable[sindex].maddr=parseInt(f.s7v.value);
            }else{
                if(('maddr' in edgemodel.ctable[sindex]))
                {
                    delete edgemodel.ctable[sindex].maddr;
                }
            }
            if(f.s8v.checked)
            {
                edgemodel.ctable[sindex].group=1;
            }else{
                edgemodel.ctable[sindex].group=0;
            }
        }
        loadslavetable(index,sindex);
        quitdevicedit();
        view_max_node(edgemodel);
    }
    button_state_deal(0,false);
    button_flag=0;//临时-debug
}
/*从机编辑界面操作动态逻辑*/
function changeslavedit()
{
    var f=document.edge;
    var mode;
    if(f.s5v.checked)
    {
        mode='block';
    }else{
        mode='none';
    }
    document.getElementById("s6").style.display=mode;
    document.getElementById("s8").style.display=mode;
    if(f.s6v.checked&&f.s5v.checked)
    {
        mode='block';
    }else{
        mode='none';
    }
    document.getElementById("s7").style.display=mode;
}
/* 
type: 0:slaver , 1:point
*/
function get_next_name(type)
{
    if(type==0)
    {
        slave_max_num=edgemodel.ctable.length+1;
        for(var i=1;i<slave_max_num+1;i++)
        {
            var flag=0;
            var next_salver_name='device'+(i<10?'0'+i:i);
            for(var j=0;j<edgemodel.ctable.length;j++)
            {
                if(next_salver_name==edgemodel.ctable[j].name)
                {
                    flag=1;
                }
            }
            if(flag==0)
            {
                return next_salver_name;
            }
        }
    }else if(type==1)
    {
        point_max_num=edgemodel.ctable[slaveselectedindex].datas.length+1;
        for(var i=1;i<point_max_num+1;i++)
        {
            var flag=0;
            var slave_num=slaveselectedindex+1;
            var next_point_name='node'+(slave_num<10?'0'+slave_num:slave_num)+(i<10?'0'+i:i);
            for(var j=0;j<edgemodel.ctable[slaveselectedindex].datas.length;j++)
            {
                if(next_point_name==edgemodel.ctable[slaveselectedindex].datas[j].name)
                {
                    flag=1;
                }
            }
            if(flag==0)
            {
                return next_point_name;
            }
        }
    }
}
/*从机编辑界面参数加载逻辑
snameindex:从机编辑模式
mode:添加从机模式
*/
function loadslavedit(snameindex,mode)
{
    var f=document.edge;
    var sname=slavename[snameindex-1];
    if(mode==2)
    {
        for(var i=0;i<edgemodel.ctable.length;i++)
        {
            if(edgemodel.ctable[i].name==sname)
            {
                f.s1v.value=edgemodel.ctable[i].name;
                f.s2v.value=edgemodel.ctable[i].port[1];
                f.s3v.value=edgemodel.ctable[i].port[2];
                if(edgemodel.ctable[i].datas.length!=0)
                {
                    f.s4v.value=edgemodel.ctable[i].datas[0].ct;
                }else{
                    f.s4v.value=edgemodel.ctable[i].ct;
                }
                f.s8v.value=edgemodel.ctable[i].group;
                if(f.s8v.value==0)
                {
                    f.s8v.checked=false;
                }else{
                    f.s8v.checked=true;
                }
                if(('maddr' in edgemodel.ctable[i]))
                {
                    f.s6v.checked=true;
                    f.s7v.value=edgemodel.ctable[i].maddr;
                }else{
                    f.s6v.checked=false;
                }
                if(f.s6v.checked||f.s8v.checked)
                {
                    f.s5v.checked=true;
                }else{
                    f.s5v.checked=false;
                }
                break;
            }
        }
    }else if(mode==1)
    {
        f.s1v.value=get_next_name(0);
        f.s3v.value='1';
        f.s4v.value=100;
        f.s5v.checked=false;
        f.s6v.checked=false;
        f.s8v.checked=false;
    }
    changeslavedit();
}
/*退出从机编辑界面
mode:0，页面加载阶段
mode:1，从机添加阶段
mode:2，从机编辑阶段
*/
function quitdevicedit()
{
    document.getElementById("slavedit").style.display = 'none';
    document.getElementById("slavedit").removeChild(deviceditc);
    button_state_deal(0,false);
    button_flag=0;//临时-debug
    document.getElementById('edgegatherslave').style.overflow='';
}
/* */
const salve_para=[
['Device name',
'Port',
'Slave Address',
'Polling interval',
'Show advanced settings',
'Enable Address mapping',
'Map Slave address',
'Merge collection'
],
['设备名称',
'串口号',
'从机地址',
'轮询间隔',
'显示高级设置',
'地址映射功能',
'映射从机地址',
'合并采集'
]
];
/* */
/*进入从机编辑界面*/
/*
*mode = 1:添加从机 按钮
*mode = 2:编    辑 按钮
*/
const remind_str="<font color='red'>*</font>";
function loadslaver(sindex,mode)
{
    // if(mode==1&&slaveindex>=slave_max_num)
    if(mode==1&&(get_max_node(edgemodel)==0))
    {
        return;
    }
    var div = document.createElement("div");
    div.id="deviceditc";
    // if(button_flag==1)
    // {
        button_flag=1;//0;
    // }
    div.innerHTML+="<li id='s1'>"
    +"<label class='label_title'>"+remind_str+salve_para[extention_para.language][0]+"</label>"/*设备名称*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='16' id='s1v' name='s1v' value='' type='text' onfocus = 'gotoldvalve(this)' onchange='check_change_edge(this,"+extention_para.language+");valuerepeat("+sindex+",0)' />"
    +"<img src='images/help.gif'  onClick='helpwindow(0)'/>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='s2'>"
    +"<label class='label_title'>"+remind_str+salve_para[extention_para.language][1]+"</label>"/*串口号*/
    +"<div class='div_node'>"
    +"<select class='select' name='s2v' id='s2v'>"
    +"<option value='1' selected='selected' id='1'>1</option>"
    +"<option value='2' id='2'>2</option>"
    +"<option value='3' id='3'>3</option>"
    +"<option value='4' id='4'>4</option>"
    +"<option value='5' id='5'>5</option>"
    +"<option value='6' id='6'>6</option>"
    +"<option value='7' id='7'>7</option>"
    +"<option value='8' id='8'>8</option>"
    +"</select>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='s3'>"
    +"<label class='label_title'>"+remind_str+salve_para[extention_para.language][2]+"</label>"/*从机地址*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='3' id='s3v' name='s3v' value='' type='number' onfocus = 'gotoldvalve(this)' onchange='valuecheck_usr(this,1,255,"+extention_para.language+",0)'/><font size='2px'>(1~255)</font>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='s4'>"
    +"<label class='label_title'>"+remind_str+salve_para[extention_para.language][3]+"</label>"/*轮询间隔*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='5' id='s4v' name='s4v' value='' type='number' onfocus = 'gotoldvalve(this)' onchange = 'valuecheck_usr(this,10,65535,"+extention_para.language+",0)'/><font size='2px'>(10~65535)ms</font>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='s5'>"
    +"<label class='label_title'>"+salve_para[extention_para.language][4]+"</label>"/*显示高级设置*/
    +"<div class='div_node'>"
    +"<input name='s5v' id='s5v' type='checkbox' value='1' onclick='changeslavedit()'/></div>"
    +"</li>";
    div.innerHTML+="<li id='s6'>"
    +"<label class='label_title'>"+salve_para[extention_para.language][5]+"</label>"/*地址映射功能*/
    +"<div class='div_node'>"
    +"<input name='s6v' id='s6v' type='checkbox' value='1' onclick='changeslavedit()'/></div>"
    +"</li>";
    div.innerHTML+="<li id='s7'>"
    +"<label class='label_title'>"+remind_str+salve_para[extention_para.language][6]+"</label>"/*映射从机地址*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='3' id='s7v' name='s7v' value='1' type='number' onfocus = 'gotoldvalve(this)' onchange = 'valuecheck_usr(this,1,255,"+extention_para.language+",0)'/><font size='2px'>(1~255)</font>"
    +"<img src='images/help.gif'  onClick='helpwindow(9)'/>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='s8'>"
    +"<label class='label_title'>"+salve_para[extention_para.language][7]+"</label>"/*合并采集*/
    +"<div class='div_node'>"
    +"<input id='s8v' name='s8v' value='' type='checkbox' onchange = ''/>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<div class='usr_submit'>"
    +"<input class='submit' id='save_slave_button' value='"+save_cancel[extention_para.language][0]+"' type='button' onclick='saveslave("+sindex+","+mode+")'/>&nbsp;&nbsp;"
    +"<input class='submit' id='cancel_slave_button' value='"+save_cancel[extention_para.language][1]+"' type='button' onclick='quitdevicedit()'/>"
    +"</div>";
    document.getElementById("slavedit").appendChild(div);
    document.getElementById("slavedit").style.display = 'block';
    auto_load_port(extention_para.portmax);
    if(mode==2||mode==1)
    {
        loadslavedit(sindex,mode);
    }
    button_state_deal(0,true);

    document.getElementById('edgegatherslave').style.overflow='hidden';
}
/*删除从机列表项
index:从机号
name:从机列表项ID
*/
function deleteslaver(index,id)
{
    for(var i=0;i<edgemodel.ctable[index-1].datas.length;i++)
    {
        delete_rtable_point(edgemodel,edgemodel.ctable[index-1].datas[i].key);
    }
    edgemodel.ctable.splice(index-1,1);
    loadgather();
    view_max_node(edgemodel);
    //TableSortera('gatherslaveform',1,2,3);/*重新排序*/
}
/*记录从机列表编号*/
var slaveindex=0;
/* 增加从机列表项
mode:
0:页面加载阶段，根据点表设备配置，加载从机列表及列表参数，不进行退出编辑处理
1:添加从机阶段，根据编辑界面配置，加载从机列表及列表参数，不进行退出编辑处理
2:编辑参数阶段，根据编辑界面配置，加载从机列表及列表参数，进行退出编辑处理
*/
function addslaver(mode)
{
    // if((mode==0||mode==1)&&slaveindex<slave_max_num)
    if((mode==0||mode==1)&&(get_max_node(edgemodel)>=0))
    {
        var f=document.edge;
        slaveindex+=1;
        var join_zp_c='background-color: white; color: #fd8448;cursor: pointer;height: 50px;text-align:center;';
        var td_usr='line-height:18px;padding:10px 10px 9px;text-align:left;vertical-align:top;border-bottom:1px solid #ddd;';
        var tb=document.getElementById('slavetbody');
        var tr=document.createElement('tr');
        tr.style.cssText=join_zp_c;
        tr.id='slavet'+slaveindex;
        tr.addEventListener('click',function(e){selectslaver(slaveindex,tr.id,0);});

        var td0=document.createElement('td');
        td0.style.cssText=td_usr;
        td0.innerHTML=slaveindex;/*从机列表序号*/
        var td1=document.createElement('td');
        td1.style.cssText=td_usr;
        td1.innerHTML=edgemodel.ctable[slaveindex-1].name;/*从机设备名*/
        slavename.push(edgemodel.ctable[slaveindex-1].name);
        var td2=document.createElement('td');
        td2.style.cssText=td_usr;
        td2.innerHTML=/*'串口'*/port_index[extention_para.language]+edgemodel.ctable[slaveindex-1].port[1];/*从机设备端口号*/
        var td3=document.createElement('td');
        td3.style.cssText=td_usr;
        td3.innerHTML=edgemodel.ctable[slaveindex-1].port[2];/*.toString(16).toUpperCase();从机地址*///parseInt(str, 16)
        var td4=document.createElement('td');
        td4.style.cssText=td_usr;
        td4.innerHTML="<input class='button_write' name='' value='"+edit_dele[extention_para.language][0]+"' type='button' onclick='loadslaver("+slaveindex+",2)'/>&nbsp;&nbsp;"
                     +"<input class='button_write' name='' value='"+edit_dele[extention_para.language][1]+"' type='button' onclick='deleteslaver("+slaveindex+","+tr.id+")'/>";
        tr.appendChild(td0);
        tr.appendChild(td1);
        tr.appendChild(td2);
        tr.appendChild(td3);
        tr.appendChild(td4);
        tb.appendChild(tr);
        //TableSortera('gatherslaveform',1,2,3);
    }
}
/*edge-point*/
/*从机列表参数加载
index:从机列表标签
sindex:从机点表标签
*/
function loadpointtable(sindex,pindex)
{
    var tr=document.getElementById('pointt'+pindex);
    var td=tr.getElementsByTagName('td');
    td[1].innerHTML=edgemodel.ctable[sindex].datas[pindex-1].name;
    td[2].innerHTML=edgemodel.ctable[sindex].datas[pindex-1].addr;
    td[3].innerHTML=datatype[extention_para.language][edgemodel.ctable[sindex].datas[pindex-1].type];
}
/*
判断数据点的变化上报是否是有意关闭
point_key：数据点key值
return：0：该点变化上报为本操作周期有意关闭 1：该点变化上报非本操作周期有意关闭
*/
disable_point_key_intentional=[];
function get_next_oprition(point_key)
{
    for(var i=0;i<disable_point_key_intentional.length;i++)
    {
        if(point_key==disable_point_key_intentional[i])
        {
            return 0;
        }
    }
    return 1;
}
/*
向数据点添加变化上报规则
type：数据点变化上报处理类型，1：添加  0：删除
file：点表json文件
point_key：根据数据点key值定位上报规则数据点
change_value：变化上报幅度参数
*/
function deal_node_change(type,file,point_key,change_value)
{
    var point_index=-1;
    var c_rid=0;
    for(var i=0;i<file.rtable.datas.length;i++)/*遍历上报规则，确定该点上报规则位置*/
    {
        if(point_key==file.rtable.datas[i].key)
        {
            point_index=i;
            break;
        }
    }
    if(point_index!=-1)
    {
        for(var j=0;j<file.rtable.datas[point_index].rid.length;j++)/*遍历该点上报规则，查询是否存在变化上报规则*/
        {
            if(file.rtable.datas[point_index].rid[j]>4)
            {
                c_rid=file.rtable.datas[point_index].rid[j];
                break;
            }
        }
    }else{
        console.log("deal_node_change: get point_index err!");
        return ;
    }
    if(type==1)//add
    {
        if(c_rid==0)//变化幅度上报规则不存在
        {
            file.rtable.rules.push(JSON.parse('{"type":3,"change":0}'));//增加上报表规则
            file.rtable.datas[point_index].rid.push(file.rtable.rules.length);//增加上报规则rid
            if(file.rtable.rules[file.rtable.datas[point_index].rid[file.rtable.datas[point_index].rid.length-1]-1].type==3&&
                'change' in file.rtable.rules[file.rtable.datas[point_index].rid[file.rtable.datas[point_index].rid.length-1]-1])//规则确认
            {
                file.rtable.rules[file.rtable.datas[point_index].rid[file.rtable.datas[point_index].rid.length-1]-1].change=change_value;//更新变化幅度上报值
            }else{
                console.log("deal_node_change: confirm rules is err!");
            }
        }else{//存在变化幅度上报
            if((file.rtable.rules[c_rid-1].type==3||file.rtable.rules[c_rid-1].type==0)&&
                'change' in file.rtable.rules[c_rid-1])//规则确认
            {
                file.rtable.rules[c_rid-1].type=3;//更新type值
                file.rtable.rules[c_rid-1].change=change_value;//更新变化幅度上报值
            }else{
                console.log("deal_node_change: confirm rules err!");
            }
        }
        /*如果该点存在不上报规则，直接移除*/
        for(var j=1;j<file.rtable.datas[point_index].rid.length;j++)
        {
            if(file.rtable.datas[point_index].rid[j]==1)
            {
                file.rtable.datas[point_index].rid.splice(j,1);
            }
        }
    }else if(type==0)//delete
    {
        if(c_rid!=0)
        {
            if(file.rtable.rules[c_rid-1].type==3&&
                'change' in file.rtable.rules[c_rid-1])//规则确认
            {
                file.rtable.rules[c_rid-1].type=0;//更新type值
                //file.rtable.rules[c_rid-1].change=change_value;//更新变化幅度上报值
                disable_point_key_intentional.push(point_key);
            }else{
                console.log("deal_node_change: rules confirm err!");
            }
        }
    }
}
/*
获取数据点有效key值
file：json点表文件
s_index：当前从机编号
*/
function get_valid_key(file,s_index)
{
    //var head=(s_index+1)+'0';
    var head=file.ctable[s_index].key+'0';
    var max_length=file.ctable[s_index].datas.length+1;
    for(var i=0;i<max_length;i++)
    {
        var key;
        var flag=0;
        var tail=((i+1)>9? (i+1):'0'+(i+1));
        for(var j=0;j<file.ctable[s_index].datas.length;j++)
        {
            var key=parseInt(head+tail);
            if(key==file.ctable[s_index].datas[j].key)
            {
                flag=1;
                break;
            }
        }
        if(flag==0)
        {
            return key;
        }
    }
}
/*记录数据点名*/
var pointname=[];
/*数据点参数保存模板*/
const pointmodel='{"key": 101,"name": "switch02","type": 1,"range": null,"defv": 1,"addr": "10001","rw": 1,"ct": 5,"to": 200,"maddr":22,"form":"%s+%s*10"}';
/*数据点编辑界面保存*/
function savepoint(sindex,pindex,mode)
{
    var f=document.edge;
    var state=checkcontentnull(1,8,mode);
    if(state==1)
    {
        if(mode==1)/*添加保存*/
        {
            if(valuerepeat(pindex,1)==0)
            {
                return;
            }
            edgemodel.ctable[slaveselectedindex].datas.push(JSON.parse(pointmodel));//ctable添加数据点
            edgemodel.rtable.datas.push(JSON.parse(report_point_model));//rtable添加数据点
            index=edgemodel.ctable[slaveselectedindex].datas.length-1;
            // edgemodel.ctable[slaveselectedindex].datas[index].key=parseInt((slaveselectedindex+1)+''+edgemodel.ctable[slaveselectedindex].datas.length);
            //var key=parseInt((slaveselectedindex+1)+'0'+(edgemodel.ctable[slaveselectedindex].datas.length>9? edgemodel.ctable[slaveselectedindex].datas.length:'0'+edgemodel.ctable[slaveselectedindex].datas.length));
            var key=get_valid_key(edgemodel,slaveselectedindex);
            edgemodel.ctable[slaveselectedindex].datas[index].key=key;/*ctable*/
            edgemodel.ctable[slaveselectedindex].datas[index].name=f.p1v.value;
            edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].key=key;/*rtable*/
            edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].name=f.p1v.value;
            /*edgemodel.ctable[slaveselectedindex].datas[index].rw=parseInt(f.p2v.value);读写性固定*/
            var value=parseInt(f.p3v.value)+1+'';
            var value_str='';
            var value_cmd;
            for(var i=value.length;i<4;i++)
            {
                value_str+='0';
            }
            if(f.p2v.value==3)
            {
                value_cmd='4';
            }else{
                value_cmd=parseInt(f.p2v.value)-1+'';
            }
            var test=value_cmd+value_str+value;
            edgemodel.ctable[slaveselectedindex].datas[index].addr=value_cmd+value_str+value;/*数据点寄存器地址(功能码+寄存器地址拼接得到)*/
            edgemodel.ctable[slaveselectedindex].datas[index].type=parseInt(f.p4v.value);/*数据点数据类型*/
            edgemodel.ctable[slaveselectedindex].datas[index].to=parseInt(f.p5v.value);/*数据点超时时间*/
            edgemodel.ctable[slaveselectedindex].datas[index].ct=edgemodel.ctable[slaveselectedindex].ct;/*数据点间隔时间依赖于从机轮询间隔设置*/
            if(f.p7v.checked)
            {
                edgemodel.ctable[slaveselectedindex].datas[index].maddr=parseInt(f.p8v.value);/*数据点映射地址*/
            }else{
                delete edgemodel.ctable[slaveselectedindex].datas[index].maddr;
            }
            if(f.p9v.value!='')
            {
                edgemodel.ctable[slaveselectedindex].datas[index].form=f.p9v.value;/*数据点计算公式*/
            }else{
                delete edgemodel.ctable[slaveselectedindex].datas[index].form;
            }
            /*数据点添加阶段，判断变化幅度上报开启*/
            if(f.p10v.checked==true)
            {
                edgemodel.rtable.rules.push(JSON.parse('{"type":3,"change":0}'));//增加上报表规则
                edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].rid.push(edgemodel.rtable.rules.length);//增加该点上报rid
                if(f.p11v.value!='')
                {
                    if(edgemodel.rtable.rules[edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].rid[edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].rid.length-1]-1].type==3&&
                      'change' in edgemodel.rtable.rules[edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].rid[edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].rid.length-1]-1])//数据点对应rule确认
                    {
                        edgemodel.rtable.rules[edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].rid[edgemodel.rtable.datas[edgemodel.rtable.datas.length-1].rid.length-1]-1].change=(f.p11v.value+'');
                    }else{
                        console.log("add point, confirm rules err!");
                    }
                }else{
                    console.log("add point,value of change is null!");
                }
            }
            addpoint(slaveselectedindex,mode);
            pindex=pointindex;
        }else if(mode==2)/*编辑保存*/
        {
            if(valuerepeat(pindex,1)==0)
            {
                return;
            }//数据点名称编辑查重
            pointname[pindex-1]=f.p1v.value;/*更新缓存从机名称*/
            edgemodel.ctable[slaveselectedindex].datas[pindex-1].name=f.p1v.value;/*从机名称*/
            /*edgemodel.ctable[slaveselectedindex].datas[pindex-1].rw=parseInt(f.p2v.value);读写性固定*/
            var value=parseInt(f.p3v.value)+1+'';
            var value_str='';
            var value_cmd;
            for(var i=value.length;i<4;i++)
            {
                value_str+='0';
            }
            if(f.p2v.value==3)
            {
                value_cmd='4';
            }else{
                value_cmd=parseInt(f.p2v.value)-1+'';
            }
            var test=value_cmd+value_str+value;
            edgemodel.ctable[slaveselectedindex].datas[pindex-1].addr=value_cmd+value_str+value;
            edgemodel.ctable[slaveselectedindex].datas[pindex-1].type=parseInt(f.p4v.value);
            edgemodel.ctable[slaveselectedindex].datas[pindex-1].to=parseInt(f.p5v.value);
            if(f.p7v.checked)
            {
                edgemodel.ctable[slaveselectedindex].datas[pindex-1].maddr=parseInt(f.p8v.value);
            }else{
                if(('maddr' in edgemodel.ctable[slaveselectedindex].datas[pindex-1]))
                {
                    delete edgemodel.ctable[slaveselectedindex].datas[pindex-1].maddr;
                }
            }
            if(f.p9v.value!='')/*计算公式*/
            {
                edgemodel.ctable[slaveselectedindex].datas[pindex-1].form=f.p9v.value;
            }else{
                if(('form' in edgemodel.ctable[slaveselectedindex].datas[pindex-1]))
                {
                    delete edgemodel.ctable[slaveselectedindex].datas[pindex-1].form;
                }
            }
            if(f.p10v.checked==true)/*变化上报*/
            {
                var change=f.p11v.value+'';
                deal_node_change(1,edgemodel,edgemodel.ctable[slaveselectedindex].datas[pindex-1].key,change);
            }else{
                deal_node_change(0,edgemodel,edgemodel.ctable[slaveselectedindex].datas[pindex-1].key,'');
            }
        }
        loadpointtable(slaveselectedindex,pindex);
        quitpointedit();
        view_max_node(edgemodel);
    }
    button_state_deal(1,false);
}
/* */
function selectpoint(id)
{
    if (document.getElementById(id) == null)
    {
        return;
    }
    if(gethexcolor(id)=='#ffffff')
    {
        autoselecttable(1);
        document.getElementById(id).style.background='#0054a4';
    }else
    {
        document.getElementById(id).style.background='#ffffff';
    }
}
/*从机编辑界面操作动态逻辑*/
function changepointedit()
{
    var f=document.edge;
    var mode;
    if(f.p6v.checked)
    {
        mode='block';
    }else{
        mode='none';
    }
    document.getElementById("p7").style.display=mode;
    document.getElementById("p9").style.display=mode;
    if(f.p7v.checked&&f.p6v.checked)
    {
        mode='block';
    }else{
        mode='none';
    }
    document.getElementById("p8").style.display=mode;
    mode='none';
    if(f.p10v.checked)
    {
        mode='block';
    }
    document.getElementById("p11").style.display=mode;
}
/*
获取当前数据点的变化上报规则状态
file：边缘计算点表json文件
s_index：查询数据点所属从机索引
n_index：查询数据点索引
return：-2：未开启 -1：有对应规则但未开启  0：有对应规则且已开启
*/
function get_node_change_sta(file,s_index,n_index)
{
    for(var i=0;i<file.rtable.datas.length;i++)
    {
        if(file.ctable[s_index].datas[n_index].key==file.rtable.datas[i].key)
        {
            if(file.rtable.datas[i].rid.length>1&&file.rtable.datas[i].rid[0]!=0)
            {
                for(var j=1;j<file.rtable.datas[i].rid.length;j++)
                {
                    if(file.rtable.datas[i].rid[j]>=5)
                    {
                        if(file.rtable.rules[file.rtable.datas[i].rid[j]-1].type==3&&file.rtable.rules[file.rtable.datas[i].rid[j]-1].change!=null)
                        {
                            return 0+","+file.rtable.rules[file.rtable.datas[i].rid[j]-1].change;
                        }else if(file.rtable.rules[file.rtable.datas[i].rid[j]-1].type==0&&file.rtable.rules[file.rtable.datas[i].rid[j]-1].change!=null)
                        {
                            return -1+","+file.rtable.rules[file.rtable.datas[i].rid[j]-1].change;
                        }
                    }
                }
            }
        }
    }
    return -2+",";
}
/* 数据点编辑界面参数加载逻辑
sindex:从机索引
pindex:数据点索引
mode:当前操作类型
1:添加
2:编辑
*/
function loadpointedit(sindex,pindex,mode)
{
    var f=document.edge;
    
    if(mode==2)
    {
        f.p1v.value=edgemodel.ctable[sindex].datas[pindex-1].name;/*数据点名称*/
        var addr=edgemodel.ctable[sindex].datas[pindex-1].addr;
        if(addr[0]==4)
        {
            f.p2v.value=3;/*功能码*/
        }else{
            f.p2v.value=parseInt(addr[0])+1;/*功能码*/
        }
        f.p3v.value=(parseInt(addr.slice(1))-1)+'';/*寄存器地址*/
        f.p4v.value=edgemodel.ctable[sindex].datas[pindex-1].type;/*数据类型*/
        f.p5v.value=edgemodel.ctable[sindex].datas[pindex-1].to;/*超时时间*/
        edgemodel.ctable[sindex].ct=edgemodel.ctable[sindex].datas[pindex-1].ct;/*同步从机轮询间隔值*/
        if(('maddr' in edgemodel.ctable[sindex].datas[pindex-1]))
        {
            f.p7v.checked=true;
            f.p8v.value=edgemodel.ctable[sindex].datas[pindex-1].maddr;
        }else{
            f.p7v.checked=false;
        }
        if(('form' in edgemodel.ctable[sindex].datas[pindex-1]))
        {
            f.p9v.value=edgemodel.ctable[sindex].datas[pindex-1].form;
        }else{
            f.p9v.value='';
        }
        if(f.p7v.checked||f.p9v.value!='')
        {
            f.p6v.checked=true;
        }else{
            f.p6v.checked=false;
        }
        var res=get_node_change_sta(edgemodel,sindex,pindex-1);
        if(parseInt(res.split(',')[0])<0)
        {
            f.p10v.checked=false;
            if(parseInt(res.split(',')[0])==-1)
            {
                f.p11v.value=/*parseInt*/(res.split(',')[1]);
            }
        }else{
            f.p10v.checked=true;
            f.p11v.value=/*parseInt*/(res.split(',')[1]);
        }
    }else if(mode==1)
    {
        f.p1v.value=get_next_name(1);
        //f.p2v.value=3;
        f.p6v.checked=false;
        f.p7v.checked=false;
        f.p9v.value='';
        f.p10v.checked=false;
    }
    changepointedit();
}
/* */
function quitpointedit()
{
    document.getElementById("pointedit").style.display = 'none';
    document.getElementById("pointedit").removeChild(pointeditc);
    button_state_deal(1,false);
    document.getElementById('edgegatherpoint').style.overflow='';
}
/* 
数据点变化上报与数据上报功能联动处理 
type: 0:数据点使能变化上报  1：数据上报关闭
*/
function auto_mode_report(type)
{
    var f=document.edge;
    if(type==0)
    {
        if(f.p10v.checked==true)
        {
            var already=0;
            for(var i=0;i<edgemodel.rtable.datas.length;i++)
            {
                for(var j=0;j<edgemodel.rtable.datas[i].rid.length;j++)
                {
                    if(edgemodel.rtable.datas[i].rid[j]>4&&
                    edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1].type==3)
                    {
                        already=1;
                        break;
                    }
                }
                if(already==1)
                {
                    break;
                }
            }
            if(already==0&&f.rp3v.value==0)
            {
                warning_str=["When the node 'Reporting on change' function is turned on, the 'Reporting method' function of 'Data Report of nodes' will be Enable  automatically!",'数据点变化上报开启后，数据上报功能自动开启！'];
                alert(warning_str[extention_para.language]);
                f.rp3v.value=1;
                edgereport();
            }
        }
    }else if(type==1)
    {
        if(f.rp3v.value==0)
        {
            for(var i=0;i<edgemodel.rtable.datas.length;i++)
            {
                for(var j=0;j<edgemodel.rtable.datas[i].rid.length;j++)
                {
                    if(edgemodel.rtable.datas[i].rid[j]>4&&edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1].type==3)
                    {
                        warning_str=["When the 'Reporting method' function of 'Data Report of nodes' is Disabled, the rules of 'Reporting on change' in nodes will be invalidated automatically!",'数据上报功能关闭后，当前数据点内存在的变化上报规则将失效！'];
                        alert(warning_str[extention_para.language]);
                        return;
                    }
                }
            }
        }else if(f.rp3v.value==1)
        {
            for(var i=0;i<edgemodel.rtable.datas.length;i++)
            {
                for(var j=0;j<edgemodel.rtable.datas[i].rid.length;j++)
                {
                    if(edgemodel.rtable.datas[i].rid[j]>4&&edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1].type==0)
                    {
                        warning_str=["When the 'Reporting method' function of 'Data Report of nodes' is Enabled, the rules whose state is disabled now of 'Reporting on change' in nodes will be valid automatically!",'数据上报功能开启后，当前数据点内存在的未开启的变化上报规则将生效！'];
                        alert(warning_str[extention_para.language]);
                        return;
                    }
                }
            }
        }
    }
}
/* */
const point_para=[
['Node name',
'Function code',
'Register address',
'Data type',
'Timeout',
'Show advanced settings',
'Enable Address mapping',
'Map node address',
'Calculation formula',
'Reporting on change',
'Variation range'
],
['数据点名称',
'功能码',
'寄存器地址',
'数据类型',
'超时时间',
'显示高级设置',
'地址映射功能',
'映射数据点地址',
'数据计算',
'变化上报',
'变化范围'
]
];
function loadpoint(sindex,pindex,mode)
{
    //if(mode==1&&pointindex>=point_max_num)
    if(mode==1&&(get_max_node(edgemodel)==0))
    {
        return;
    }
    var div = document.createElement("div");
    div.id="pointeditc";

    div.innerHTML+="<li id='p1'>"
    +"<label class='label_title'>"+remind_str+point_para[extention_para.language][0]+"</label>"/*数据点名称*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='16' id='p1v' name='p1v' value='' type='text' onfocus = 'gotoldvalve(this)' onchange='check_change_edge(this,"+extention_para.language+");valuerepeat("+pindex+",1)'/>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='p2'>"
    +"<label class='label_title'>"+remind_str+point_para[extention_para.language][1]+"</label>"/*功能码*/
    +"<div class='div_node'>"
    +"<select class='select' name='p2v' id='p2v'>"
    +"<option value=1>01</option>"
    +"<option value=2>02</option>"
    +"<option value=3 selected='selected'>03</option>"
    +"<option value=4>04</option>"
    +"</select>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='p3'>"
    +"<label class='label_title'>"+remind_str+point_para[extention_para.language][2]+"</label>"/*寄存器地址*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='5' id='p3v' name='p3v' value='0' type='number' onfocus = 'gotoldvalve(this)' onchange = 'valuecheck_usr(this,0,65534,"+extention_para.language+",0)'/><font size='2px'>(0~65534)</font>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='p4'>"
    +"<label class='label_title'>"+remind_str+point_para[extention_para.language][3]+"</label>"/*数据类型*/
    +"<div class='div_node'>"
    +"<select class='select' name='p4v' id='p4v'>"
    +"<option value=2>"+datatype[extention_para.language][2]+"</option>"
    +"<option value=3>"+datatype[extention_para.language][3]+"</option>"
    +"<option value=4 selected='selected'>"+datatype[extention_para.language][4]+"</option>"
    +"<option value=5>"+datatype[extention_para.language][5]+"</option>"
    +"<option value=6>"+datatype[extention_para.language][6]+"</option>"
    +"<option value=7>"+datatype[extention_para.language][7]+"</option>"
    +"<option value=8>"+datatype[extention_para.language][8]+"</option>"
    +"<option value=9>"+datatype[extention_para.language][9]+"</option>"
    +"<option value=10>"+datatype[extention_para.language][10]+"</option>"
    +"<option value=11>"+datatype[extention_para.language][11]+"</option>"
    +"<option value=12>"+datatype[extention_para.language][12]+"</option>"
    +"<option value=1>"+datatype[extention_para.language][1]+"</option>"
    +"</select>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='p5'>"
    +"<label class='label_title'>"+remind_str+point_para[extention_para.language][4]+"</label>"/*超时时间*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='5' id='p5v' name='p5v' value='200' type='number' onfocus = 'gotoldvalve(this)' onchange = 'valuecheck_usr(this,10,65535,"+extention_para.language+",0)'/><font size='2px'>(10~65535)ms</font>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='p10'>"
    +"<label class='label_title'>"+point_para[extention_para.language][9]+"</label>"/*变化上报*/
    +"<div class='div_node'>"
    +"<input name='p10v' id='p10v' type='checkbox' value='1' onchange='changepointedit();auto_mode_report(0)'/></div>"
    +"</li>";
    div.innerHTML+="<li id='p11'>"
    +"<label class='label_title'>"+remind_str+point_para[extention_para.language][10]+"</label>"/*变化范围*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='5' id='p11v' name='p11v' value='2' type='number' onfocus = 'gotoldvalve(this)' onchange = 'valuecheck_usr(this,0,65535,"+extention_para.language+",0)'/>"
    +"<img src='images/help.gif' onclick='helpwindow(5)'>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='p6'>"
    +"<label class='label_title'>"+point_para[extention_para.language][5]+"</label>"/*显示高级设置*/
    +"<div class='div_node'>"
    +"<input name='p6v' id='p6v' type='checkbox' value='1' onchange='changepointedit()'/></div>"
    +"</li>";
    div.innerHTML+="<li id='p7'>"
    +"<label class='label_title'>"+point_para[extention_para.language][6]+"</label>"/*地址映射功能*/
    +"<div class='div_node'>"
    +"<input name='p7v' id='p7v' type='checkbox' value='1' onchange='changepointedit()'/></div>"
    +"</li>";
    div.innerHTML+="<li id='p8'>"
    +"<label class='label_title'>"+remind_str+point_para[extention_para.language][7]+"</label>"/*映射数据点地址*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='5' id='p8v' name='p8v' value='0' type='number'  onfocus = 'gotoldvalve(this)' onchange = 'valuecheck_usr(this,0,65534,"+extention_para.language+",0)'/><font size='2px'>(0~65534)</font>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<li id='p9'>"
    +"<label class='label_title'>"+point_para[extention_para.language][8]+"</label>"/*数据计算*/
    +"<div class='div_node'>"
    +"<input class='input_text' maxlength='32' id='p9v' name='p9v' value='' type='text' oninput='OnIpnut(event)' onfocus = 'gotoldvalve(this)' onchange='data_calculation_check(this,"+extention_para.language+")'/>"
    +"<img src='images/help.gif'  onClick='helpwindow(11)'/>"
    +"</div>"
    +"</li>";
    div.innerHTML+="<div class='usr_submit'>"
    +"<input class='submit' id='save_point_button' value='"+save_cancel[extention_para.language][0]+"' type='button' onclick='savepoint("+sindex+","+pindex+","+mode+")'/>&nbsp;&nbsp;"
    +"<input class='submit' id='cancel_point_button' value='"+save_cancel[extention_para.language][1]+"' type='button' onclick='quitpointedit()'/>"
    +"</div>"
    +"<br\>";
    document.getElementById("pointedit").appendChild(div);
    document.getElementById("pointedit").style.display = 'block';
    if(mode==2||mode==1)
    {
        loadpointedit(sindex,pindex,mode);
    }
    button_state_deal(1,true);
    document.getElementById('edgegatherpoint').style.overflow='hidden';
}
/* */
const datatype=[['','Bool','uint8','int8','uint16','int16','uint32(ABCD)','uint32(CDAB)','int32(ABCD)','int32(CDAB)','float32(ABCD)','float32(CDAB)','float64'],
['','Bool','8位无符号','8位有符号','16位无符号','16位有符号','32位无符号(ABCD)','32位无符号(CDAB)','32位有符号(ABCD)','32位有符号(CDAB)','32位浮点数(ABCD)','32位浮点数(CDAB)','64位浮点数']];
var pointindex=0;
function addpoint(sindex,mode)
{
    //if((mode==0||mode==1)&&pointindex<point_max_num)
    if((mode==0||mode==1)&&(get_max_node(edgemodel)>=0))
    {
        pointindex+=1;
        var join_zp_c='background-color: white; color: #fd8448;cursor: pointer;height: 50px;text-align:center;';
        var td_usr='line-height:18px;padding:10px 10px 9px;text-align:left;vertical-align:top;border-bottom:1px solid #ddd;';
        
        var tb=document.getElementById('pointtbody');
        var tr=document.createElement('tr');
        tr.style.cssText=join_zp_c;
        tr.id='pointt'+pointindex;
        tr.addEventListener('click',function(e){selectpoint(tr.id);});

        var td0=document.createElement('td');
        td0.style.cssText=td_usr;
        td0.innerHTML=pointindex;
        var td1=document.createElement('td');
        td1.style.cssText=td_usr;
        td1.innerHTML=edgemodel.ctable[sindex].datas[pointindex-1].name;/*数据点名称*/
        pointname.push(edgemodel.ctable[sindex].datas[pointindex-1].name);
        var td2=document.createElement('td');
        td2.style.cssText=td_usr;
        td2.innerHTML=edgemodel.ctable[sindex].datas[pointindex-1].addr;/*寄存器地址*/
        var td3=document.createElement('td');
        td3.style.cssText=td_usr;
        td3.innerHTML=datatype[extention_para.language][edgemodel.ctable[sindex].datas[pointindex-1].type];/*数值类型*/
        var td4=document.createElement('td');
        td4.style.cssText=td_usr;
        td4.innerHTML="<input class='button_write' name='' value='"+edit_dele[extention_para.language][0]+"' type='button' onclick='loadpoint("+sindex+","+pointindex+",2)'/>&nbsp;&nbsp;"
                     +"<input class='button_write' name='' value='"+edit_dele[extention_para.language][1]+"' type='button' onclick='deletepoint("+pointindex+","+tr.id+")'/>";

        tr.appendChild(td0);
        tr.appendChild(td1);
        tr.appendChild(td2);
        tr.appendChild(td3);
        tr.appendChild(td4);
        tb.appendChild(tr);
        //TableSorterb('gatherpointform',1,2,3);
    }
}
/*
上报表摘除节点
file：json点表文件
point_key：数据点key值
*/
function delete_rtable_point(file,point_key)
{
    var rtable_datas_length=0;
    var c_rid=-1;
    for(var i=0;i<file.rtable.datas.length;i++)
    {
        if(point_key==file.rtable.datas[i].key)
        {
            for(var j=0;j<file.rtable.datas[i].rid.length;j++)
            {
                if(file.rtable.datas[i].rid[j]>4)
                {
                    c_rid=file.rtable.datas[i].rid[j];
                    break;
                }
            }
            file.rtable.datas.splice(i,1);//删除上报表数据点
        }
        if(c_rid!=-1)
        {
            break;//已找到数据点且需要的信息已全部拿到，直接终止遍历
        }
    }
    if(c_rid!=-1)//若摘除的数据点存在变化上报规则
    {
        file.rtable.rules.splice(c_rid-1,1);//根据rid定位、摘除变化幅度上报规则
        for(var i=0;i<file.rtable.datas.length;i++)//再次遍历上报表数据点
        {
            for(var j=0;j<file.rtable.datas[i].rid.length;j++)
            {
                if(file.rtable.datas[i].rid[j]>4&&file.rtable.datas[i].rid[j]>c_rid)//若该点存在变化上报规则，且其变化上报规则在摘除规则之后
                {
                    file.rtable.datas[i].rid[j]-=1;//变化幅度上报规则rid前移
                }
            }
        }
    }
}
/*
数据点删除
*/
function deletepoint(pindex,name)
{
    delete_rtable_point(edgemodel,edgemodel.ctable[slaveselectedindex].datas[pindex-1].key);
    edgemodel.ctable[slaveselectedindex].datas.splice(pindex-1,1);
    document.getElementById("pointtbody").removeChild(name);
    loadpointable(slaveselectedindex);
    view_max_node(edgemodel);
    //TableSorterb('gatherpointform',1,2,3);
}
/* 遍历所有根据数据点“ defv ”判断失败填充是否开启
只要有一个数据点defv不为‘null’，功能即开启
*/
// function geterrstren()
// {var f=document.edge;f.rp34v.checked=false;
//     for(var i=0;i<edgemodel.ctable.length;i++)
//     {
//         for(j=0;j<edgemodel.ctable[i].datas.length;j++)
//         {
//             if(edgemodel.ctable[i].datas[j].defv!='null')
//             {
//                 f.rp34v.checked=true;
//                 f.rp341v.value=edgemodel.ctable[i].datas[j].defv;
//                 return;
//             }
//         }
//     }
// }
/* 根据点表判断数据上报功能是否开启;同步加载数据点上报规则
开启：return 1
关闭：return 0
*/
function getreporten()
{var res=0;var f=document.edge;
    f.rp31v.checked=false;
    //f.rp32v.checked=false;
    f.rp33v.checked=false;
    if(edgemodel.rtable.datas.length)
    {
        f.rp1v.value=edgemodel.rtable.datas[0].sid;
        for(var i=0;i<edgemodel.rtable.datas.length;i++)
        {
            if(edgemodel.rtable.datas[i].rid.length>1/*&&edgemodel.rtable.datas[i].rid[1]!=1*/)
            {
                //"rules":[{"type":0},{"type":1,"period":0},{"type":2},{"type":4,"nature":"h"}]
                for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
                {
                    if(edgemodel.rtable.datas[i].rid[j]==2)
                    {
                        f.rp31v.checked=true;
                        f.rp311v.value=edgemodel.rtable.rules[1].period;
                        res=1;
                    }/*else if(edgemodel.rtable.datas[i].rid[j]==4)
                    {
                        f.rp32v.checked=true;
                        f.rp321v.value=edgemodel.rtable.rules[3].change;
                    }*/else if(edgemodel.rtable.datas[i].rid[j]==4)
                    {
                        f.rp33v.checked = true;
                        if (edgemodel.rtable.rules[3].nature == 1)
                        {
                          f.rp331v.value=edgemodel.rtable.rules[3].nature;                            
                        }
                        else
                        {
                            var stmp = edgemodel.rtable.rules[3].nature; 
                            f.rp331v.value = stmp.slice(0, 1);
                            if (stmp.length > 1)
                            {
                                f.rp331v1.value = stmp.slice(2, 4);
                                f.rp331v2.value = stmp.slice(5, 7);
                            }
                        }
                        res=1;
                    }else if(edgemodel.rtable.datas[i].rid[j]>4)
                    {
                        if(edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1].type==3)
                        {
                            res=1;
                        }
                    }
                }
                // res=1;
                // break;
            }
        }
    }
    return res;
}
/*加载上报界面参数 */
function loadedgereport()
{
    var f=document.edge;
    if('rtable' in edgemodel&&'datas' in edgemodel.rtable)
    {
        if(edgemodel.rtable.datas.length>0)
        {
            f.rp1v.value=edgemodel.rtable.datas[0].sid;
        }
    }
    // f.rp1v.value=edgemodel.rtable.server[0];
    f.inqu_en.value=econfig.inqu_en;
    f.inqu_m.value=econfig.inqu_m;
    f.inqu_t.value=econfig.inqu_t;
    f.inqu_qos.value=econfig.inqu_qos;
    if(edgemodel.rtable.server.length!=0&&edgemodel.rtable.topics.length!=0)
    {
        f.rp23v.value=edgemodel.rtable.topics[0];
        f.rp23sv.value=f.rp23v.value;
    }
    f.rp24v.value=edgemodel.rtable.qos;
    f.rp24sv.value=f.rp24v.value;
    f.rp3v.value=getreporten();
    // geterrstren();
    if('filling' in edgemodel.rtable)
    {
        f.rp34v.checked=true;
        f.rp341v.value=edgemodel.rtable.filling;
    }else{
        f.rp34v.checked=false;
    }
    if(edgemodel.rtable.format[0].type==1)
    {
        f.rp35v.checked=false;
    }else{
        f.rp35v.checked=true;
    }
    f.rp36v.value=JSON.stringify(edgemodel.rtable.format[0].template);
    edgereport();
    
}
/* 通道选项自适应显示*/
function SetmiscDefaults()
{
  for(var i=8; i >0;i--)
  {
    if (i >extention_para.portmax)
    { 
      document.getElementById('socket'+i).style.display="none";
    }
    else
    {
      document.getElementById('socket'+i).style.display="block";
    } 
  }
}
/* */
way_id=["optreportway1","optreportway2","optreportway0"];
way_sta=[" (Not enabled)"," (未开启)"];
function edgereport()
{
    if(!Array.prototype.indexOf)
    {
        Array.prototype.indexOf=function(obj,start){
        for(var index=(start || 0), j=this.length;index<j;index++){
            if(this[index]===obj){ 
            return index; 
            }
        }
        return -1;
        }
    }
    var pub_str=[['Jump to web of ','Alibaba Cloud','AWS iot','MQTT Gateway',', Continue configuration'],['跳转到 ','阿里云','亚马逊云','MQTT',' 页面继续配置']];
    var test_str;
    var f=document.edge;
    SetmiscDefaults();
    // if(f.rp1v.value<=8)
    // {
    //     test_str=pub_str[extention_para.language][0]+'Socket'+f.rp1v.value+pub_str[extention_para.language][4];
    // }else{
    //     test_str=pub_str[extention_para.language][0]+pub_str[extention_para.language][f.rp1v.value-9]+pub_str[extention_para.language][4];
    // }
    //document.getElementById('jumpbutton').value=test_str;//暂时屏蔽通道跳转
    if(f.rp1v.value>8)
    {
        var status=extention_para.edgeways.split(',');
        if(status[f.rp1v.value-10]==0)
        {
            var value=document.getElementById(way_id[f.rp1v.value-10]).innerHTML;
            if(value.indexOf("(")==-1)
            {
                document.getElementById(way_id[f.rp1v.value-10]).innerHTML=value+way_sta[extention_para.language];
            }
        }
    }
    document.getElementById("rp21").style.display='none';
    document.getElementById("rp22").style.display='none';
    document.getElementById("rp221").style.display='none';
    document.getElementById("rp23").style.display='none';
    document.getElementById("rp24").style.display='none';
    document.getElementById("rp23s").style.display='none';
    document.getElementById("rp24s").style.display='none';
    document.getElementById("rp31").style.display='none';
    document.getElementById("rp311").style.display='none';
    // document.getElementById("rp32").style.display='none';
    // document.getElementById("rp321").style.display='none';
    document.getElementById("rp33").style.display='none';
    document.getElementById("rp331").style.display='none';
    document.getElementById("rp34").style.display='none';
    document.getElementById("rp341").style.display='none';
    document.getElementById("rp35").style.display='none';
    document.getElementById("rp36").style.display='none';
    if(f.rp3v.value==1&&f.inqu_en.value==0)
    {
        document.getElementById("auto_report_para_tag_up").style.display=="none";
        document.getElementById("auto_report_para_tag_down").style.display=="block";
    }else{
        document.getElementById("auto_report_para_tag_up").style.display=="block";
        document.getElementById("auto_report_para_tag_down").style.display=="none";
    }
    if(f.inqu_en.value==1)
    {
        document.getElementById("rp21").style.display='block';
        if(f.rp1v.value>8)
        {
            document.getElementById("rp22").style.display='block';
            document.getElementById("rp221").style.display = 'block';
            
            if (f.rp1v.value == 10 || f.rp1v.value == 11)
            { 
                document.getElementById("qqos2").style.display ="none";
            }
            else
            {
                document.getElementById("qqos2").style.display ="block";
            }

        }
    }
    /*上报主题加载逻辑*/
    if(f.rp1v.value>8)
    {
        if(f.rp3v.value==1||f.inqu_en.value==1)
        {
            if(f.rp3v.value==1&&f.inqu_en.value==0)
            {
                document.getElementById("rp23s").style.display='block';
                document.getElementById("rp24s").style.display='block';
            }else{
                document.getElementById("rp23").style.display='block';
                document.getElementById("rp24").style.display='block';
            }
            if (f.rp1v.value == 10 || f.rp1v.value == 11) {         //sgb 20220402 aws ali can not have qos2
                document.getElementById("rqos2").style.display = 'none';
                document.getElementById("r2qos2").style.display = 'none';
            }
            else { 
                document.getElementById("rqos2").style.display = 'block';
                document.getElementById("r2qos2").style.display = 'block';                
            }
        }

    }
    if(f.rp3v.value==1)
    {
        // if(f.rp1v.value>8)
        // {
        //     if(f.rp3v.value==1&&f.inqu_en.value==0)
        //     {
        //         document.getElementById("rp23s").style.display='block';
        //         document.getElementById("rp24s").style.display='block';
        //     }else{
        //         document.getElementById("rp23").style.display='block';
        //         document.getElementById("rp24").style.display='block';
        //     }
        // }
        document.getElementById("rp31").style.display='block';
        if(f.rp31v.checked==true)
        {
            document.getElementById("rp311").style.display='block';
        }
        //document.getElementById("rp32").style.display='block';
        // if(f.rp32v.checked==true)
        // {
        //     document.getElementById("rp321").style.display='block';
        // }
        document.getElementById("rp33").style.display='block';
        if(f.rp33v.checked==true)
        {
            document.getElementById("rp331").style.display='block';
        }
        if (f.rp331v.value == "t") {
            document.getElementById("hm").style.display = 'block';
        }
        else { 
            document.getElementById("hm").style.display = 'none';
        }
        document.getElementById("rp34").style.display='block';
        if(f.rp34v.checked==true)
        {
            document.getElementById("rp341").style.display='block';
        }
        document.getElementById("rp35").style.display='block';
        document.getElementById("rp36").style.display='block';
    }else if(f.rp3v.value==0)
    {
        f.rp31v.checked=false;
        f.rp33v.checked=false;
        f.rp34v.checked=false;
        f.rp35v.checked=false;
    }
}


/* 
src:检查位置，0:输入即检查 1：保存检查 
id：参数标签id
*/
function JSON_STR_CHECK(src,name)
{
    name.value = name.value.replace(/[\u4e00-\u9fa5\u3002\uff1b\uff0c\uff1a\u201c\u201d\uff08\uff09\u3001\uff1f\u300a\u300b]/ig,'');
    var str=name.value;
    warning_str=[[['The input string cannot be converted to json '],['输入的字符串，无法转换为json']],[['The input string of Json template cannot be converted to json '],['Json模板参数输入的字符串，无法转换为json']]]
    if (typeof str == 'string') {
        try {
            if(str.indexOf('{')==-1||str.indexOf('}')==-1)
            {
                name.value = old_valve;                
                alert(warning_str[src][extention_para.language]);
                return false;
            }
            var obj=JSON.parse(str);
            return obj;
        } catch(e) {
            //console.log('error：'+str+'!!!'+e);
            //document.getElementById(id).value='';
            name.value = old_valve            
            alert(warning_str[src][extention_para.language]);
            return false;
        }
    }
    alert(warning_str[src][extention_para.language]);
    return false;
    //console.log('It is not a string!')
}
/* */
const change_report_model='{"type":3,"change":"2"}';
const report_rule='{"filling":"err","server":["sock1","sock2","sock3","sock4","sock5","sock6","sock7","sock8","usrcloud","alicloud","awscloud","mqtt"],"topics":["topic"],"qos":0,"format":[{"type": 1,"template":{"a":"json"}}],"rules":[{"type":0},{"type":1,"period":0},{"type":2},{"type":4,"nature":"h"}],"datas": []}';
const report_point_model='{"key": 1,"name": "pointname","rid": [1],"sid": 1,"tid": 1,"fid": 1}';
function updata_edge_model()
{var f=document.edge;var old_rtable;
    if('rtable' in edgemodel)
    {
        old_rtable=edgemodel.rtable;
        //delete edgemodel.rtable;不进行rtable删除
        //edgemodel.rtable=(JSON.parse(report_rule));/*上报模板拼接*/
    }
    //edgemodel.rtable=(JSON.parse(report_rule));/*上报模板拼接*/
    /*edgemodel.rtable.server[0]=f.rp1v.value;/*通道;通道固定*/
    if((f.rp3v.value==1||f.inqu_en.value==1)&&f.rp1v.value>8)/*查询、上报任一功能开启，进行发布主题配置*/
    {
        edgemodel.rtable.topics[0]=f.rp23v.value;
        edgemodel.rtable.qos=parseInt(f.rp24v.value);
    }else{
        /*delete edgemodel.rtable.topics;/*删除topic字段*/
        /*delete edgemodel.rtable.qos;/*删除qos字段*/
    }
    if(f.rp3v.value==0)/*上报关闭，将所有数据点上报格式改为不上报(处理rid，其他规则保留)*/
    {
        if('filling' in edgemodel.rtable)
        {
            delete edgemodel.rtable.filling;/*删除filling字段*/
        }
        for(var i=0;i<edgemodel.rtable.datas.length;i++)
        {
            /*遍历所有上报规则，移除变化幅度上报+不上报外的规则rid，变化上报规则内的type字段置为：0 */
            for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
            {
                if(edgemodel.rtable.datas[i].rid[j]<=4&&edgemodel.rtable.datas[i].rid[j]>1)
                {
                    edgemodel.rtable.datas[i].rid.splice(j,1);
                }else if(edgemodel.rtable.datas[i].rid[j]>4)
                {
                    if(edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1].type==3&&
                    'change' in edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1])
                    {
                        edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1].type=0;
                    }else{
                        console.log("updata_edge_model: confirm rules err!");
                    }
                }
            }
            /*如果当前数据点上报规则为空，数据点补充不上报规则*/
            if(edgemodel.rtable.datas[i].rid.length<=1)
            {
                var times=2-edgemodel.rtable.datas[i].rid.length;
                for(var j=0;j<times;j++)
                {
                    edgemodel.rtable.datas[i].rid.push(1);
                }
            }
            edgemodel.rtable.datas[i].sid=parseInt(f.rp1v.value);/*通道号*/
        }
    }else if(f.rp3v.value==1)/*上报开启*/
    {
        if(f.rp34v.checked==true)
        {
            edgemodel.rtable.filling=f.rp341v.value;
        }else{
            delete edgemodel.rtable.filling;/*删除filling字段*/
        }
        /*遍历上报表数据点*/
        for(var i=0;i<edgemodel.rtable.datas.length;i++)
        {
            var sta=0;
            if(f.rp31v.checked==true)/*增加 or 修改 周期上报规则*/
            {
                if(edgemodel.rtable.datas[i].rid.length>1)
                {
                    for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
                    {
                        if(edgemodel.rtable.datas[i].rid[j]==2)
                        {
                            sta=1;break;
                        }
                    }
                }
                if(sta==0)
                {
                    for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
                    {
                        if(edgemodel.rtable.datas[i].rid[j]==1)
                        {
                            edgemodel.rtable.datas[i].rid.splice(j,1);/*移除不上报规则*/
                        }
                    }
                    edgemodel.rtable.datas[i].rid.push(2);
                }
                edgemodel.rtable.rules[1].period=parseInt(f.rp311v.value);
            }else{/*移除周期上报规则*/
                for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
                {
                    if(edgemodel.rtable.datas[i].rid[j]==2)
                    {
                        edgemodel.rtable.datas[i].rid.splice(j,1);/*只移除周期上报规则，周期参数不做处理*/
                    }
                }
            }
            sta=0;
            if(f.rp33v.checked==true)/*增加 or 修改 定时上报规则*/
            {
                if(edgemodel.rtable.datas[i].rid.length>1)
                {
                    for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
                    {
                        if(edgemodel.rtable.datas[i].rid[j]==4)
                        {
                            sta=1;break;
                        }
                    }
                }
                if(sta==0)
                {
                    for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
                    {
                        if(edgemodel.rtable.datas[i].rid[j]==1)
                        {
                            edgemodel.rtable.datas[i].rid.splice(j,1);/*移除不上报规则*/
                        }
                    }
                    edgemodel.rtable.datas[i].rid.push(4);
                }
                if (f.rp331v.value == "t" && (f.rp331v1.value == "" || f.rp331v2.value == "")) { 
                    f.rp331v.value = "h"
                }
                if (f.rp331v.value == "t")
                {
                    edgemodel.rtable.rules[3].nature = "t" + ":" + f.rp331v1.value + ":" + f.rp331v2.value;
                }
                else {
                    edgemodel.rtable.rules[3].nature = f.rp331v.value;
                }
                
            }else{/*移除定时上报规则*/
                for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
                {
                    if(edgemodel.rtable.datas[i].rid[j]==4)
                    {
                        edgemodel.rtable.datas[i].rid.splice(j,1);/*只移除定时上报规则，定时参数不做处理*/
                    }
                }
            }
            /*如果存在未开启的变化上报规则，主动开启该规则*/
            if(get_next_oprition(edgemodel.rtable.datas[i].key)==1)//过滤故意关闭的变化上报点
            {
                for(var j=1;j<edgemodel.rtable.datas[i].rid.length;j++)
                {
                    if(edgemodel.rtable.datas[i].rid[j]>4)
                    {
                        if(edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1].type==0&&
                        'change' in edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1])
                        {
                            edgemodel.rtable.rules[edgemodel.rtable.datas[i].rid[j]-1].type=3;
                        }else{
                            console.log("updata_edge_model: rules check err!");
                        }
                    }
                }
            }
            /*如果当前数据点上报规则为空，数据点补充不上报规则*/
            if(edgemodel.rtable.datas[i].rid.length<=1)
            {
                var times=2-edgemodel.rtable.datas[i].rid.length;
                for(var j=0;j<times;j++)
                {
                    edgemodel.rtable.datas[i].rid.push(1);
                }
            }
            /*更新通道号*/
            edgemodel.rtable.datas[i].sid=parseInt(f.rp1v.value);
            /* fid固定，不做处理*/
        }
        if(f.rp35v.checked==true)/*引号包含*/
        {
            edgemodel.rtable.format[0].type=2;
        }else{
            edgemodel.rtable.format[0].type=1;
        }
        if(JSON_STR_CHECK(1,f.rp36v)!=false)
        {
            edgemodel.rtable.format[0].template=JSON.parse(f.rp36v.value);
        }
        else{
            return false;
        }
    }
    disable_point_key_intentional=[];//清空记录
}
/*禁止表单元素提交*/
function forbid_tag_submit(form,action)
{
    tag_type=['select','input','textarea'];
    for(var j=0;j<tag_type.length;j++)
    {
        var tag_name = form.getElementsByTagName(tag_type[j]);
        for(i=0;i<tag_name.length;i++)
        {
            if(tag_name[i].id != "edgeen"&&tag_name[i].id != "inqu_en"&&tag_name[i].id != "inqu_m"&&tag_name[i].id != "inqu_t"&&tag_name[i].id != "inqu_qos")
            {
                tag_name[i].disabled = action;
            }
        }
    }
}
/*边缘计算参数保存逻辑 */
function save_edge(name)
{
    //var value=document.getElementById("edge");
    if(updata_edge_model()==false)
    {
        return false;
    }
    checkForm(name);
    uploadedge('edgemodel','/edge_model');
    forbid_tag_submit(name,true);
    //document.getElementById("edge").submit();
    usr_form_submit('econfig');
}

/*边缘计算数据计算检验 */
function data_calculation_check(name,langeuage)
{
    var value = name.value;
    if(value.length == 0)
    {
        return;
    }
    if(value.substr(0,1) == '=')
    {
        return;
    }
    else
    {
        if(langeuage == 1)
        {
            alert("缺少'='!");
        }
        else
        {
            alert("Missing '='!")
        }
        name.value = old_valve;
        return;
    }
}

function regreport() {
    var f = document.edge
    if (f.rp331v.value == "t") {
        document.getElementById("rp331v1").style.display = "block"
        document.getElementById("rp331v2").style.display = "block"
        document.getElementById("hm").style.display = "block"
    }
    else
    {
        document.getElementById("rp331v1").style.display = "none"
        document.getElementById("rp331v2").style.display = "none"   
        document.getElementById("hm").style.display = "none"
    }

}

function valuecheck_edge_usr(name, min, max, language)
{
    name.value = name.value.replace(/[\u4e00-\u9fa5\u3002\uff1b\uff0c\uff1a\u201c\u201d\uff08\uff09\u3001\uff1f\u300a\u300b\s]/ig,'');
    var value = name.value;
    var str = '';
    var valid_flag = 0;
    var arr = value.split('');

    if(value.length == 0)
    {
        name.value = old_valve;
        if(language == 1)
        {
            alert("请输入合法字符！");
        }
        else
        {
            alert("Please enter valid characters!")
        }
        return;
    }
    else
    {
        for(var i = 0; i < value.length; i++)
        {
            if((arr[i] < '0') || (arr[i] > '9'))
            {
                name.value = old_valve;
                if(language == 1)
                {
                    alert("请输入合法字符！");
                }
                else
                {
                    alert("Please enter valid characters!")
                }
                return;
            }
            else
            {
                if((arr[i] >= '0') && (arr[i] <= '9') && (valid_flag == 0))
                {
                    valid_flag = 1;
                }
                if(valid_flag == 1)
                {
                    str += arr[i];
                }
            }
        }
        if(valid_flag == 0)
        {
            str += '0';
        }
    }
    if (str.length == 1)
    {
        str = "0" + str
    }
    name.value =str;
    if (value > max) 
    {
        name.value =max;
        if(language == 1)
        {
            alert("输入的值超过最大值，请重新输入!");
        }
        else
        {
            alert("Error: Exceed maximum,please enter it again!");
        }
    }

}



/*
 * 特殊处理，边缘计算点表不可以设置空格
 */
function check_change_edge(name,langeuage)
{
    name.value = name.value.replace(/[\u4e00-\u9fa5\u3002\uff1b\uff0c\uff1a\u201c\u201d\uff08\uff09\u3001\uff1f\u300a\u300b\s]/ig,'');
    var value=name.value;
    if(value.length == 0)
    {
        name.value = old_valve;
        if(langeuage == 1)
        {
            alert("无效参数!");
        }
        else
        {
            alert("Invalid parameter!")
        }
        return;
    }
}

