/* get mqtt configs*/
var mqtt_base;
var mqtt_pub;
var mqtt_sub;
var extension_para;
const tab_name=['h2','set','tabbase','tabpub','tabsub','enablem','optmqen1','optmqen2','mqttp','mqttidtab','mqtturltab','mqttporttab','mqttheart','mqttndrttab','mqttrttab','mqttcsctab','mqttvrftab','mqttusertab','mqttpasstab','mqttwftab','mqttwtoptab','mqttwmsgtab','mqttwrtdtab','sslcontenttab','optsslm1','optsslv1','optsslv2','optsslv3','scatab','path11','scacfbutton','upgrade1','ccatab','path21','ccacfbutton','upgrade2','cpwtab','path31','cpwcfbutton','upgrade3','pusrtab','optpusr1','optpusr2','pusrbindp','firstpub','firstsub','submitback','savebutton'];
const tab_value=[
['MQTT Gateway','MQTT Gateway function supports SSL, clean session and QOS, supports connecting to the third-party MQTT server.It supports up to 16 publish topics and 16 subscribe topics, supports port mapping function, which can bind each topic to a different serial port.','Basic configuration','Publish','Subscribe','Enable MQTT','Disable','Enable','MQTT Version','Client ID','Server Address (IP)','Local/Remote Port NO.','Keepalvie Interval','Reconnecting time Without Data','Reconnection Interval','Clean up session','User Credentials','Username','Password','Enable last will','Topic of will','Will Message','Retained','SSL protocol','Disable','None','Verify server certificate','Verify All','Upload Server CA','Server Root CA','Choose file','Upload...','Upload Client CA','Client CA','Choose file','Upload...','Upload Client Private Key','Client Private Key','Choose file','Upload...','Custom mode','Disable','Enable','Binding port','Publish topic1','Subscribe topic1','Go back','Save&Apply'],
['MQTT网关','支持SSL、清理会话、遗言、QOS等功能，支持对接第三方MQTT服务器。最多支持16个发布主题和16个订阅主题；支持端口映射功能，每个主题可单独映射到不同串口。','基础配置','发布配置','订阅配置','MQTT使能','关闭','开启','MQTT协议','客户ID','服务器域名(IP)','本地/远程端口号','心跳时间','无数据重连时间','重连间隔时间','清理会话','连接验证','用户名','密码','遗言使能','遗言主题','遗言内容','保留消息','SSL加密','关闭','不验证证书','验证服务器证书','双向验证','服务器根证书上传','请选择服务器证书','选择文件','上传...','客户端证书上传','请选择客户端证书','选择文件','上传...','客户端私钥上传','请选择客户端私钥','选择文件','上传...','自定义模式','关闭','开启','绑定端口','发布主题1','订阅主题1','返回','保存&应用']
];
function get_extension()
{
const url = 'temp.json'
const getJsonContent = function (url) {
var xhr = new XMLHttpRequest();
xhr.open("get", url);/*设置请求方法与路径*/
xhr.onreadystatechange = function () { 
// readyState == 4说明请求已完成
if (xhr.readyState == 4 && xhr.status == 200) {
localStorage.setItem('jsonFileContent', xhr.responseText)
//console.log(xhr.responseText);
// 获取
var json_test=localStorage.getItem('jsonFileContent')
extension_para=JSON.parse(json_test);
loadlanguage(tab_name,tab_value,extension_para.language,' ');
load_ca_name(extension_para.mqttca,extension_para.language);
loadpublic(0);
creat_box('selectdiv');//加载复选下拉框
loaddefault(0);
loaddefault(1);
popup_pub(extension_para.language);
if(extension_para.webjump=='1')
{
  document.getElementById('submitback').style.display='inline';
  document.getElementById('savebutton').style.display='none';
}else{
  document.getElementById('submitback').style.display='none';
  document.getElementById('savebutton').style.display='inline';
}
}
}
xhr.send();
}
getJsonContent(url)
}
function get_sub_file()
{
    const url = 'mqttsub.json'
    const getJsonContent = function (url) {
    var xhr = new XMLHttpRequest();
    xhr.open("get", url);/*设置请求方法与路径*/
    xhr.onreadystatechange = function () { 
      // readyState == 4说明请求已完成
      if (xhr.readyState == 4 && xhr.status == 200) {
        localStorage.setItem('jsonFileContent', xhr.responseText)
        //console.log(xhr.responseText);
        // 获取
        var json_test=localStorage.getItem('jsonFileContent')
        mqtt_sub=JSON.parse(json_test);
        get_extension();
      }
    }
    xhr.send();
    }
    getJsonContent(url)
}
function get_pub_file()
{
    const url = 'mqttpub.json'
    const getJsonContent = function (url) {
    var xhr = new XMLHttpRequest();
    xhr.open("get", url);/*设置请求方法与路径*/
    xhr.onreadystatechange = function () { 
      // readyState == 4说明请求已完成
      if (xhr.readyState == 4 && xhr.status == 200) {
        localStorage.setItem('jsonFileContent', xhr.responseText)
        //console.log(xhr.responseText);
        // 获取
        var json_test=localStorage.getItem('jsonFileContent')
        mqtt_pub=JSON.parse(json_test);
        get_sub_file();
      }
    }
    xhr.send();
    }
    getJsonContent(url)
}
function get_file()
{
    const url = 'mqttbase.json'
    const getJsonContent = function (url) {
    var xhr = new XMLHttpRequest();
    xhr.open("get", url);/*设置请求方法与路径*/
    xhr.onreadystatechange = function () { 
      // readyState == 4说明请求已完成
      if (xhr.readyState == 4 && xhr.status == 200) {
        localStorage.setItem('jsonFileContent', xhr.responseText)
        //console.log(xhr.responseText);
        // 获取
        var json_test=localStorage.getItem('jsonFileContent')
        mqtt_base=JSON.parse(json_test);
        get_pub_file();
      }
    }
    xhr.send();
    }
    getJsonContent(url)
}
/* 遗言主题 */ 
wtop_warning_str=[
    ['The format of the Will Topic does not conform to the specification'],
    ['遗言主题格式不符合规范']
    ]
    function check_wtop(langeuage,name)
    {
        var value=name.value;
        var index1 = value.indexOf('#');
        var index2 = value.indexOf('+');
        if((index1>=0) || (index2>=0))
        {
            alert(wtop_warning_str[langeuage][0]);
            name.value = old_valve;
        }
    }
/* */
const helpstr=[
    ['In custom mode, just need to fill in the correct publish parameters before the real data without configuring the publish topics. For example, when we send “/pub1,0,off,hello” from the serial port, it will publish “hello” to the topic “/pub1”.',
    "Transparent transmission: Directly publish data of the bound serial port to the corresponding topic.\nTopic distribution: You can set the topic name when configuring the publish topics.The device will publish the data of the bound serial port to the related topics according to the topic name.",
    "Without topic: Transparently transmits the received data to the bound serial port.\nWith topic: Add the topic before the received data, default format is: topic,payload."
    ],
    ['无需预先配置发布主题，只需在发布的数据前面按格式填入发布参数即可，例如：发送/pub1,0,off,hello字符串会将hello自动推送至/pub1主题。\n',
    "透传模式:将所绑定串口接收到的数据直接推送至对应主题。\n主题分发模式:配置主题的时候可以定义此主题的主题名称，设备从所绑定串口收到数据后会根据主题名称推送至与之关联的主题。",
    "透传模式:将接收到的数据以透传的方式传输到绑定的串口。\n带主题下发模式:带主题下发是指将订阅收到的消息前面加上主题，随payload一起下发，数据默认格式为：topice,payload。"
    ]
    ];
    function mqtt_helpwindow(index)
    {
        alert(helpstr[extension_para.language][index]);
    }
/*public*/
function changemqttsate()
{
    var f = document.mqttbase;
    if(f.mqtten.value==0)
    {
        document.getElementById("mqtver").style.display="none";
        document.getElementById("mqttid").style.display="none";
        document.getElementById("mqtturl").style.display="none";
        document.getElementById("mqttport").style.display="none";
        document.getElementById("mqttht").style.display="none";
        document.getElementById("mqttndrt").style.display="none";
        document.getElementById("mqttrt").style.display="none";
        document.getElementById("mqttcsc").style.display="none";
        document.getElementById("mqttvrf").style.display="none";
        document.getElementById("mqttuser").style.display="none";
        document.getElementById("mqttpass").style.display="none";
        document.getElementById("mqttwf").style.display="none";
        document.getElementById("mqttwtop").style.display="none";
        document.getElementById("mqttwmsg").style.display="none";
        document.getElementById("mqttwqos").style.display="none";
        document.getElementById("mqttwrtd").style.display="none";
        document.getElementById("sslcontent").style.display="none";
        document.getElementById("sca").style.display="none";
        document.getElementById("cca").style.display="none";
        document.getElementById("cpw").style.display="none";
    }
    else
    {
        document.getElementById("mqtver").style.display="block";
        document.getElementById("mqttid").style.display="block";
        document.getElementById("mqtturl").style.display="block";
        document.getElementById("mqttport").style.display="block";
        document.getElementById("mqttht").style.display="block";
        document.getElementById("mqttndrt").style.display="block";
        document.getElementById("mqttrt").style.display="block";
        document.getElementById("mqttcsc").style.display="block";
        document.getElementById("mqttvrf").style.display="block";
        if(f.mqv.checked==true)
        {
            document.getElementById("mqttuser").style.display="block";
            document.getElementById("mqttpass").style.display="block";
        }
        else
        {
            document.getElementById("mqttuser").style.display="none";
            document.getElementById("mqttpass").style.display="none";
        }
        document.getElementById("mqttwf").style.display="block";
        if(f.wf.checked==true)
        {
            document.getElementById("mqttwtop").style.display="block";
            document.getElementById("mqttwmsg").style.display="block";
            document.getElementById("mqttwqos").style.display="block";
            document.getElementById("mqttwrtd").style.display="block";
        }
        else
        {
            document.getElementById("mqttwtop").style.display="none";
            document.getElementById("mqttwmsg").style.display="none";
            document.getElementById("mqttwqos").style.display="none";
            document.getElementById("mqttwrtd").style.display="none";
        }
        document.getElementById("sslcontent").style.display="block";
        if(f.sslm.value==0)
        {
            f.sslv.value='0';
            f.sslv.disabled = true;
            document.getElementById("sca").style.display="none";
            document.getElementById("cca").style.display="none";
            document.getElementById("cpw").style.display="none";
        }
        else
        {
            f.sslv.disabled = false;
            if(f.sslv.value==0)
            {
                document.getElementById("sca").style.display="none";
                document.getElementById("cca").style.display="none";
                document.getElementById("cpw").style.display="none";
            }
            else if(f.sslv.value==1)
            {
                document.getElementById("sca").style.display="block";
                document.getElementById("cca").style.display="none";
                document.getElementById("cpw").style.display="none";
            }
            else if(f.sslv.value==2)
            {
                document.getElementById("sca").style.display="block";
                document.getElementById("cca").style.display="block";
                document.getElementById("cpw").style.display="block";
            }
        }
    }
    tabcontrol('mqtten',3);
}
function loadpublic(mode)
{var f=document.mqttbase;
if(mode==0)
{
    f.mqtten.value=mqtt_base.mqtten;
    f.mqttver.value=mqtt_base.mqttver;
    f.cid.value=mqtt_base.cid;
    f.addr.value=mqtt_base.addr;
    f.lpt.value=mqtt_base.lpt;
    f.rpt.value=mqtt_base.rpt;
    f.ka.value=mqtt_base.ka;
    f.ndtrct.value=mqtt_base.ndtrct;
    f.rctime.value=mqtt_base.rctime;
    if(mqtt_base.cs==1)
    {
        f.cs.checked = true;
    }
    else
    {
        f.cs.checked = false;
    }
    if(mqtt_base.mqv==1)
    {
        f.mqv.checked=true;
    }
    else
    {
        f.mqv.checked=false;
    }
    f.usr.value=mqtt_base.usr;
    f.pwd.value=mqtt_base.pwd;
    if(mqtt_base.wf==1)
    {
        f.wf.checked=true;
    }else{
        f.wf.checked=false;
    }
    f.wtop.value=mqtt_base.wtop;
    f.wmsg.value=mqtt_base.wmsg;
    f.wqos.value= mqtt_base.wqos;
    if(mqtt_base.wrtd==1)
    {
        f.wrtd.checked=true;
    }
    else
    {
        f.wrtd.checked =false;
    }
    f.sslm.value=mqtt_base.sslm;
    f.sslv.value=mqtt_base.sslv;
}
changemqttsate();
}
/* */
function changepubmode(mode)
{var f=document.mqttpub;
    var penname='puben';
    var staname='pen';
    var pcname='pubcontent';
    if(f.pusr.value==1)
    {
        document.getElementById('pusrpttag').style.display='block';
        if(mode==1)
        {
            for(var i=1;i<17;i++)
            {
                var enname=penname+i;
                var cname=pcname+i;
                if(document.getElementById(enname))
                {
                    document.getElementById(enname).style.display='none';
                }
                if(document.getElementById(cname))
                {
                    document.getElementById(cname).style.display='none';
                }
            }
        }
    }else{
        document.getElementById('pusrpttag').style.display='none';
        if(mode==1)
        {
            for(var i=1;i<17;i++)
            {
                var enname=penname+i;
                var cname=pcname+i;
                var sta=staname+i;
                if(document.getElementById(enname))
                {
                    document.getElementById(enname).style.display='block';
                }
                if(document.getElementById(cname))
                {
                    if(document.getElementById(sta).checked==true)
                    {
                        document.getElementById(cname).style.display='block';
                    }
                }
            }
        }
    }
    if(mode==1)
    {
        hide_checkbox(mqtt_pub,0);
    }
}
//pub
function loaddefault(type)
{
    if(type==0)
    {
        document.getElementById('pusr').value=mqtt_pub.pusr;
        loadmultiselect('pusrpt',mqtt_pub.pusrpt); //下拉框参数加载
        if(mqtt_pub.pusr==0)
        {
            for(var i=1;i< 17;i++)
            {
                document.getElementById("pen"+i+"").checked =true;
                loadnext(0,"pen"+i+"",extension_para.language);
                if(document.getElementById('puben'+i))
                {
                    if(mqtt_pub['pen'+i]==0)
                    {
                        document.getElementById("pen"+i+"").checked =false;
                        set_position('pen'+i,'pubcontent'+i);
                    }else
                    {
                        document.getElementById("pen"+i+"").checked =true;
                        loadcontent(0,"pen"+i+"",extension_para.language);
                        loadnext(0,"pen"+i+"",extension_para.language);
                    }
                }
                else
                {
                    if(mqtt_pub['pen'+i]==1)
                    {
                        document.getElementById("pen"+(i-1)+"").checked =true;
                        loadnext(0,"pen"+(i-1)+"",extension_para.language);
                        document.getElementById("pen"+(i-1)+"").checked =false;
                        document.getElementById("pen"+i+"").checked =true;
                        loadcontent(0,"pen"+i+"",extension_para.language);
                        loadnext(0,"pen"+i+"",extension_para.language);
                    }
                }
            }
        }
        else
        {
            document.getElementById("puben1").style.display = "none";
        }
        changepubmode(0);
    }
    else
    {
        for(var i=1;i< 17;i++)
        {
            document.getElementById("sen"+i+"").checked =true;
            loadnext(1,"sen"+i+"",extension_para.language);
            if(document.getElementById('suben'+i))
            {
                if(mqtt_sub['sen'+i]==0)
                {
                    document.getElementById("sen"+i+"").checked =false;
                }else
                {
                    document.getElementById("sen"+i+"").checked =true;
                    loadcontent(1,"sen"+i+"",extension_para.language);
                    loadnext(1,"sen"+i+"",extension_para.language);
                }
            }
            else
            {
                if(mqtt_sub['sen'+i]==1)
                {
                    document.getElementById("sen"+(i-1)+"").checked =true;
                    loadnext(1,"sen"+(i-1)+"",extension_para.language);
                    document.getElementById("sen"+(i-1)+"").checked =false;
                    document.getElementById("sen"+i+"").checked =true;
                    loadcontent(1,"sen"+i+"",extension_para.language);
                    loadnext(1,"sen"+i+"",extension_para.language);
                }
            }
        }
    }
}
/*发布：type=0，订阅：type=1。传输模式切换页面元素加载功能*/
function changemode(type,index)
{
    if(index==0)
    {}else
    {
        if(type==0)
        {
            if(document.getElementById('pmd'+index).value==0)//透传模式
            {
                document.getElementById("pubtag"+index).style.display = "none";
            }
            else
            {
                document.getElementById("pubtag"+index).style.display = "block";
            }
        }
        else
        {
            if(document.getElementById('smd'+index).value==0)//透传模式
            {
                document.getElementById("subcut"+index).style.display = "none";
            }
            else
            {
                document.getElementById("subcut"+index).style.display = "block";
            }
        }
    }
}

/* 页面元素加载、添加完成后进行参数的加载*/
function loadtopic(type,index)
{
    if(type==0)
    {
        //document.getElementById('pusr').value=mqtt_para.pusr;
        if(mqtt_pub['pen'+index]==1)
        {
            document.getElementById('pen'+index).checked=true;
        }else
        {
            document.getElementById('pen'+index).checked=false;
        }
        document.getElementById('pmd'+index).value=mqtt_pub['pmd'+index]
        document.getElementById('ptop'+index).value=mqtt_pub['ptop'+index]
        document.getElementById('ptag'+index).value=mqtt_pub['ptag'+index]
        loadmultiselect('ppt'+index,mqtt_pub['ppt'+index]);
        document.getElementById('pqos'+index).value=mqtt_pub['pqos'+index]
        if(mqtt_pub['prtd'+index]==1)
        {
            document.getElementById('prtd'+index).checked=true;
        }else{
            document.getElementById('prtd'+index).checked=false;
        }
    }else if(type==1)
    {
        if(mqtt_sub['sen'+index]==1)
        {
            document.getElementById('sen'+index).checked=true;
        }else
        {
            document.getElementById('sen'+index).checked=false;
        }
        document.getElementById('smd'+index).value=mqtt_sub['smd'+index]
        document.getElementById('stop'+index).value=mqtt_sub['stop'+index]
        document.getElementById('scut'+index).value=mqtt_sub['scut'+index]
        loadmultiselect('spt'+index,mqtt_sub['spt'+index]);
        document.getElementById('sqos'+index).value=mqtt_sub['sqos'+index]
    }
    changemode(type,index);
}
/*加载页面元素
type:       pub(0), sub(1)
id:         
language:   en(0), cn(1)
*/
const load_topic_para=[
['Transmission Mode','Transparent transmission','Topic distribution','Transmission Mode','Without Topic','With Topic','Topic String','Delimiter','Topic name','Binding port','Retained message'],
['传输模式','透传模式','主题分发模式','传输模式','透传模式','带主题下发模式','Topic字符串','分隔符','主题名称','绑定端口','保留消息']
];
function loadcontent(type,id,language)
{
    var ID;
    var mddn,mdpn;
    var topdn,toppn;
    var tagdn,tagpn;
    var ptdn,ptpn;
    var qosdn,qospn;
    var rtddn,rtdpn;
    var cutdn,cutpn;
    var check_name;
    var dev_name,dev_sname;
    var click_para;
    if(type==0)
    {
        ID = id.split('pen');
        mddn='pubmd'+ID[1];mdpn='pmd'+ID[1];
        topdn='pubtop'+ID[1];toppn='ptop'+ID[1];
        tagdn='pubtag'+ID[1];tagpn='ptag'+ID[1];
        ptdn='pubpt'+ID[1];ptpn='ppt'+ID[1];
        qosdn='pubqos'+ID[1];qospn='pqos'+ID[1];
        rtddn='pubrtd'+ID[1];rtdpn='prtd'+ID[1];
        check_name='pen'+ID[1];
        dev_name='pubcontent'+ID[1];
        dev_sname='pubcontents'+ID[1];
        click_para= 'selectdiv'+topdn;
    }else if(type==1)
    {
        ID = id.split('sen');
        mddn='submd'+ID[1];mdpn='smd'+ID[1];
        topdn='subtop'+ID[1];toppn='stop'+ID[1];
        cutdn='subcut'+ID[1];cutpn='scut'+ID[1];
        ptdn='subpt'+ID[1];ptpn='spt'+ID[1];
        qosdn='subqos'+ID[1];qospn='sqos'+ID[1];
        check_name='sen'+ID[1];
        dev_name='subcontent'+ID[1];
        dev_sname='subcontents'+ID[1];
        click_para= 'selectdiv'+topdn;
    }

    if(document.getElementById(check_name).checked)
    {
        var div = document.createElement("div");
        div.id = dev_sname;
        {
            if(type==0)
            {
                div.innerHTML = "<li id='"+mddn+"'>"
                +"<label class='label_title_uar'>"+load_topic_para[language][0]+"</label>"/*传输模式*/
                +"<div class='div_node'>"
                +"<select class='select' name='"+mdpn+"' id='"+mdpn+"' onclick='changemode(0,"+ID[1]+")'>"
                +"<option value='0' selected='selected'>"+load_topic_para[language][1]+"</option>"/*透传模式*/
                +"<option value='1'>"+load_topic_para[language][2]+"</option>"/*主题分发模式*/
                +"</select>"
                +"<img src='images/help.gif'  onClick='mqtt_helpwindow(1)'/>"
                +"</div>"
                +"</li>";
            }
            else if(type==1)
            {
                div.innerHTML = "<li id='"+mddn+"'>"
                +"<label class='label_title_uar'>"+load_topic_para[language][3]+"</label>"/*传输模式*/
                +"<div class='div_node'>"
                +"<select class='select' name='"+mdpn+"' id='"+mdpn+"' onclick='changemode(1,"+ID[1]+")'>"
                +"<option value='0' selected='selected'>"+load_topic_para[language][4]+"</option>"/*透传模式*/
                +"<option value='1'>"+load_topic_para[language][5]+"</option>"/*带主题下发模式*/
                +"</select>"
                +"<img src='images/help.gif'  onClick='mqtt_helpwindow(2)'/>"
                +"</div>"
                +"</li>";
            }
            if(type==0)
            {
                div.innerHTML+="<li id='"+topdn+"'>"
                +"<label class='label_title_uar'>"+load_topic_para[language][6]+"</label>"/*PUBTopic字符串*/
                +"<div class='div_node'>"
                +"<input class='input_text' type='text' size='15' maxlength='128' id='"+toppn+"' name='"+toppn+"' onfocus = 'gotoldvalve(this)' onchange ='check_change(this,"+language+");check_pubtop("+language+",this)'/>"
                +"</div>"
                +"</li>";
            }
            else if (type==1)
            {
                div.innerHTML+="<li id='"+topdn+"'>"
                +"<label class='label_title_uar'>"+load_topic_para[language][6]+"</label>"/*SUBTopic字符串*/
                +"<div class='div_node'>"
                +"<input class='input_text' type='text' size='15' maxlength='128' id='"+toppn+"' name='"+toppn+"' onfocus = 'gotoldvalve(this)' onchange ='check_change(this,"+language+");check_subtop("+language+",this)'/>"
                +"</div>"
                +"</li>";
            }
            if(type==1)
            {
                div.innerHTML+="<li id='"+cutdn+"'>"
                +"<label class='label_title_uar'>"+load_topic_para[language][7]+"</label>"/*分隔符*/
                +"<div class='div_node'>"
                +"<input class='input_text' type='text' size='15' maxlength='16' id='"+cutpn+"' name='"+cutpn+"' onfocus = 'gotoldvalve(this)' onchange ='check_change_separator(this,"+language+")'/>"
                +"</div>"
                +"</li>";
            }
            if(type==0)
            {
                div.innerHTML+="<li id='"+tagdn+"'>"
                +"<label class='label_title_uar'>"+load_topic_para[language][8]+"</label>"/*主题名称*/
                +"<div class='div_node'>"
                +"<input class='input_text' type='text' size='15' maxlength='64' id='"+tagpn+"' name='"+tagpn+"' onfocus = 'gotoldvalve(this)' onchange ='check_change_t(this,"+language+")'/>"
                +"</div>"
                +"</li>";
            }
            div.innerHTML+="<li id='"+ptdn+"'>"
            +"<label class='label_title_uar'>"+load_topic_para[language][9]+"</label>"/*绑定端口*/     
            +"<div class='div_node'>"
            +"<span style='width:200px;height:20px;overflow:hidden;'>"
            +"<input type='text' id='selectButton"+click_para+"' onclick=myclick('"+click_para+"'); readonly='true'"
            +"style='width:200px;height:20px;font-size:12px;' name='"+ptpn+"' value=''></inut>"
            +"</span>"
            +"<span id='"+click_para+"'"
            +"style='display:none;border:1px solid #A9A9A9;width:200px;overflow-y :scroll;height:100px;background-color:white;font-size:12px; '"
            +"onMouseOver='mousein()' onMouseOut='mouseout()'>"
            +"</span>"
            +"</div>"
            +"</li>";
            div.innerHTML+="<li id='"+qosdn+"'>"
            +"<label class='label_title_uar'>QOS</label>"
            +"<div class='div_node'>"
            +"<select class='select' name='"+qospn+"' id='"+qospn+"' onclick='changemode("+type+","+ID[1]+")'>"
            +"<option value='0' selected='selected'>QOS0</option>"
            +"<option value='1'>QOS1</option>"
            +"<option value='2'>QOS2</option>"
            +"</select>"
            +"</div>"
            +"</li>";
            if(type==0)
            {
                div.innerHTML+="<li id='"+rtddn+"'>"
                +"<label class='label_title_uar'>"+load_topic_para[language][10]+"</label>"/*保留消息*/
                +"<div class='div_node'>"
                +"<input name='"+rtdpn+"' id='"+rtdpn+"' type='checkbox' value='1'/></div>"
                +"</li>";
            }
        }
        document.getElementById(dev_name).appendChild(div);
        set_position(id,dev_name);
        creat_box('selectdiv'+topdn+'');//加载复选下拉框
        if(type==0)
        {
            mqtt_pub[check_name]=1;
        }else if(type==1){
            mqtt_sub[check_name]=1;
        }
        loadtopic(type,ID[1]);
        document.getElementById(check_name).checked = 1;
        document.getElementById(check_name).value = 1;
    }
    else
    {
        if(type==0)
        {
            mqtt_pub[check_name]=0;
        }else if(type==1){
            mqtt_sub[check_name]=0;
        }
        document.getElementById(check_name).checked = 0;
        document.getElementById(check_name).value = 0;
        document.getElementById(dev_name).removeChild(document.getElementById(dev_sname))
        set_position(id,dev_name);
    }
}
/*next 显示处理*/
const next_topic=[['Publish topic','Subscribe topic'],['发布主题','订阅主题']];
function loadnext(type,id,language)
{
    var ID ;
    if(type==0)
    {
        ID=id.split('pen');
    }
    else
    {
        ID=id.split('sen');
    }
    var index= parseInt(ID[1])+1;
    var contentready = false;
    var id_check = 0;
    var check_name;
    var enname,staname,tagname;
    if(type==0)
    {
        if(document.getElementById('puben'+index))
        {
            contentready=true;
        }
        check_name='pen'+ID[1];

        enname='puben';
        staname='pen';
        tagname='pubcontent';
    }else
    {
        if(document.getElementById('suben'+index))
        {
            contentready=true;
        }
        check_name='sen'+ID[1];

        enname='suben';
        staname='sen';
        tagname='subcontent';
    }
    if(document.getElementById(check_name).checked && !contentready && index < 17)
    {
        var div=document.createElement("div")
        if(type==0)
        {
            id="pen"+index;
            div.id='puben'+index
        }else if(type==1)
        {
            id="sen"+index;
            div.id='suben'+index
        }
        if(type==0)
        {
            div.innerHTML="<li id='puben"+index+"'>"
            +"<label class='label_title'>"+next_topic[language][0]+index+"</label>"
            +"<div class='div_node'>"
            +"<input name='pen"+index+"' id='pen"+index+"' type='checkbox' value='0' onclick='clickevent("+type+",id,"+language+")'/></div>"
            +"</li>"
            +"<div id='pubcontent"+index+"' class='card' style='display:none; position: relative;left:200px'></div>";
        }else
        {
            div.innerHTML="<li id='suben"+index+"'>"
            +"<label class='label_title'>"+next_topic[language][1]+index+"</label>"
            +"<div class='div_node'>"
            +"<input name='sen"+index+"' id='sen"+index+"' type='checkbox' value='0' onclick='clickevent(1,id,+"+language+")'/></div>"
            +"</li>"
            +"<div id='subcontent"+index+"' class='card' style='display:none; position: relative;left:200px'></div>";
        }
        if(type==0)
        {
            document.getElementById("allpub").appendChild(div);
        }
        else
        {
            document.getElementById("allsub").appendChild(div);
        }
    }
    if(index<=16)
    {
        if(contentready)
        {
            document.getElementById(enname+index).style.display = "block";
            set_position(staname+index,tagname+index);
        }
    }
    if(document.getElementById(staname+ID[1]).checked == 0 ){
        for(var i= 16;i >= 1;i--){
            if(document.getElementById(enname+i)){
                null_pubtopic = i;
                break;
            }
        }
        for(var j= null_pubtopic;j >= 1;j--){
            if (document.getElementById(staname+j).checked == 1){
                id_check = j;
                break;
            }
        }
        if(id_check < null_pubtopic){
            for(var k = id_check+2;k<=null_pubtopic;k++){
                document.getElementById(enname+k).style.display="none";
                set_position(staname+k,tagname+k);
            }
        }
    }
}
/*加载页面元素
type:       pub(0), sub(1)
id:         
language:   en(0), cn(1)
*/
function clickevent(type,id,language)
{
    loadcontent(type,id,language);
    loadnext(type,id,language);
}

//鼠标点击事件，如果点击在 selectedbutton，或者是在多选框div中的点击事件，不作处理。其他情况的点击事件，将多选空div隐藏
document.onclick = function (event) {
    if(!Array.prototype.indexOf)
    {
        Array.prototype.indexOf=function(obj,start){
        for(var index=(start || 0), j=this.length;index<j;index++){
            if(this[index]===obj){ 
            return index; 
            }
        }
        return -1;
        }
    }
    if (event.target.id.indexOf("selectButton") > -1 || indiv) {
        return;
    }
    var selectdiv = document.getElementById('selectdiv'); //selectdiv  selecteddiv
    selectdiv.style.display = "none";
};
