// var cbi_d = [];
// var cbi_t = [];
// var cbi_c = [];

// var cbi_validators = {

// 	'integer': function()
// 	{
// 		return (this.match(/^-?[0-9]+$/) != null);
// 	},

// 	'uinteger': function()
// 	{
// 		return (cbi_validators.integer.apply(this) && (this >= 0));
// 	},

// 	'float': function()
// 	{
// 		return !isNaN(parseFloat(this));
// 	},

// 	'ufloat': function()
// 	{
// 		return (cbi_validators['float'].apply(this) && (this >= 0));
// 	},

// 	'ipaddr': function()
// 	{
// 		return cbi_validators.ip4addr.apply(this) ||
// 			cbi_validators.ip6addr.apply(this);
// 	},

// 	'ip4addr': function()
// 	{
// 		if(!Array.prototype.indexOf)
// 		{
// 			Array.prototype.indexOf=function(obj,start){
// 			for(var index=(start || 0), j=this.length;index<j;index++){
// 				if(this[index]===obj){ 
// 				return index; 
// 				}
// 			}
// 			return -1;
// 			}
// 		}
// 		if (this.match(/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})(\/(\S+))?$/))
// 		{
// 			return (RegExp.$1 >= 0) && (RegExp.$1 <= 255) &&
// 			       (RegExp.$2 >= 0) && (RegExp.$2 <= 255) &&
// 			       (RegExp.$3 >= 0) && (RegExp.$3 <= 255) &&
// 			       (RegExp.$4 >= 0) && (RegExp.$4 <= 255) &&
// 			       ((RegExp.$6.indexOf('.') < 0)
// 			          ? ((RegExp.$6 >= 0) && (RegExp.$6 <= 32))
// 			          : (cbi_validators.ip4addr.apply(RegExp.$6)))
// 			;
// 		}

// 		return false;
// 	},

// 	'ip6addr': function()
// 	{
// 		if( this.match(/^([a-fA-F0-9:.]+)(\/(\d+))?$/) )
// 		{
// 			if( !RegExp.$2 || ((RegExp.$3 >= 0) && (RegExp.$3 <= 128)) )
// 			{
// 				var addr = RegExp.$1;

// 				if( addr == '::' )
// 				{
// 					return true;
// 				}

// 				if( addr.indexOf('.') > 0 )
// 				{
// 					var off = addr.lastIndexOf(':');

// 					if( !(off && cbi_validators.ip4addr.apply(addr.substr(off+1))) )
// 						return false;

// 					addr = addr.substr(0, off) + ':0:0';
// 				}

// 				if( addr.indexOf('::') >= 0 )
// 				{
// 					var colons = 0;
// 					var fill = '0';

// 					for( var i = 1; i < (addr.length-1); i++ )
// 						if( addr.charAt(i) == ':' )
// 							colons++;

// 					if( colons > 7 )
// 						return false;

// 					for( var i = 0; i < (7 - colons); i++ )
// 						fill += ':0';

// 					if (addr.match(/^(.*?)::(.*?)$/))
// 						addr = (RegExp.$1 ? RegExp.$1 + ':' : '') + fill +
// 						       (RegExp.$2 ? ':' + RegExp.$2 : '');
// 				}

// 				return (addr.match(/^(?:[a-fA-F0-9]{1,4}:){7}[a-fA-F0-9]{1,4}$/) != null);
// 			}
// 		}

// 		return false;
// 	},

// 	'port': function()
// 	{
// 		return cbi_validators.integer.apply(this) &&
// 			(this >= 0) && (this <= 65535);
// 	},

// 	'portrange': function()
// 	{
// 		if (this.match(/^(\d+)-(\d+)$/))
// 		{
// 			var p1 = RegExp.$1;
// 			var p2 = RegExp.$2;

// 			return cbi_validators.port.apply(p1) &&
// 			       cbi_validators.port.apply(p2) &&
// 			       (parseInt(p1) <= parseInt(p2))
// 			;
// 		}
// 		else
// 		{
// 			return cbi_validators.port.apply(this);
// 		}
// 	},

// 	'macaddr': function()
// 	{
// 		return (this.match(/^([a-fA-F0-9]{2}:){5}[a-fA-F0-9]{2}$/) != null);
// 	},

// 	'host': function()
// 	{
// 		return cbi_validators.hostname.apply(this) ||
// 			cbi_validators.ipaddr.apply(this);
// 	},

// 	'hostname': function()
// 	{
// 		if (this.length <= 253)
// 			return (this.match(/^[a-zA-Z0-9]+$/) != null ||
// 			        (this.match(/^[a-zA-Z0-9_][a-zA-Z0-9_\-.]*[a-zA-Z0-9]$/) &&
// 			         this.match(/[^0-9.]/)));

// 		return false;
// 	},

// 	'network': function()
// 	{
// 		return cbi_validators.uciname.apply(this) ||
// 			cbi_validators.host.apply(this);
// 	},

// 	'wpakey': function()
// 	{
// 		var v = this;

// 		if( v.length == 64 )
// 			return (v.match(/^[a-fA-F0-9]{64}$/) != null);
// 		else
// 			return (v.length >= 8) && (v.length <= 63);
// 	},

// 	'wepkey': function()
// 	{
// 		var v = this;

// 		if ( v.substr(0,2) == 's:' )
// 			v = v.substr(2);

// 		if( (v.length == 10) || (v.length == 26) )
// 			return (v.match(/^[a-fA-F0-9]{10,26}$/) != null);
// 		else
// 			return (v.length == 5) || (v.length == 13);
// 	},

// 	'uciname': function()
// 	{
// 		return (this.match(/^[a-zA-Z0-9_]+$/) != null);
// 	},

// 	'range': function(min, max)
// 	{
// 		var val = parseFloat(this);
// 		if (!isNaN(min) && !isNaN(max) && !isNaN(val))
// 			return ((val >= min) && (val <= max));

// 		return false;
// 	},

// 	'min': function(min)
// 	{
// 		var val = parseFloat(this);
// 		if (!isNaN(min) && !isNaN(val))
// 			return (val >= min);

// 		return false;
// 	},

// 	'max': function(max)
// 	{
// 		var val = parseFloat(this);
// 		if (!isNaN(max) && !isNaN(val))
// 			return (val <= max);

// 		return false;
// 	},

// 	'rangelength': function(min, max)
// 	{
// 		var val = '' + this;
// 		if (!isNaN(min) && !isNaN(max))
// 			return ((val.length >= min) && (val.length <= max));

// 		return false;
// 	},

// 	'minlength': function(min)
// 	{
// 		var val = '' + this;
// 		if (!isNaN(min))
// 			return (val.length >= min);

// 		return false;
// 	},

// 	'maxlength': function(max)
// 	{
// 		var val = '' + this;
// 		if (!isNaN(max))
// 			return (val.length <= max);

// 		return false;
// 	},

// 	'or': function()
// 	{
// 		for (var i = 0; i < arguments.length; i += 2)
// 		{
// 			if (typeof arguments[i] != 'function')
// 			{
// 				if (arguments[i] == this)
// 					return true;
// 				i--;
// 			}
// 			else if (arguments[i].apply(this, arguments[i+1]))
// 			{
// 				return true;
// 			}
// 		}
// 		return false;
// 	},

// 	'and': function()
// 	{
// 		for (var i = 0; i < arguments.length; i += 2)
// 		{
// 			if (typeof arguments[i] != 'function')
// 			{
// 				if (arguments[i] != this)
// 					return false;
// 				i--;
// 			}
// 			else if (!arguments[i].apply(this, arguments[i+1]))
// 			{
// 				return false;
// 			}
// 		}
// 		return true;
// 	},

// 	'neg': function()
// 	{
// 		return cbi_validators.or.apply(
// 			this.replace(/^[ \t]*![ \t]*/, ''), arguments);
// 	},

// 	'list': function(subvalidator, subargs)
// 	{
// 		if (typeof subvalidator != 'function')
// 			return false;

// 		var tokens = this.match(/[^ \t]+/g);
// 		for (var i = 0; i < tokens.length; i++)
// 			if (!subvalidator.apply(tokens[i], subargs))
// 				return false;

// 		return true;
// 	},
// 	'phonedigit': function()
// 	{
// 		return (this.match(/^[0-9\*#!\.]+$/) != null);
// 	}
// };


// function cbi_d_add(field, dep, next) {
// 	var obj = document.getElementById(field);
// 	if (obj) {
// 		var entry
// 		for (var i=0; i<cbi_d.length; i++) {
// 			if (cbi_d[i].id == field) {
// 				entry = cbi_d[i];
// 				break;
// 			}
// 		}
// 		if (!entry) {
// 			entry = {
// 				"node": obj,
// 				"id": field,
// 				"parent": obj.parentNode.id,
// 				"next": next,
// 				"deps": []
// 			};
// 			cbi_d.unshift(entry);
// 		}
// 		entry.deps.push(dep)
// 	}
// }

// function cbi_d_checkvalue(target, ref) {
// 	var t = document.getElementById(target);
// 	var value;

// 	if (!t) {
// 		var tl = document.getElementsByName(target);

// 		if( tl.length > 0 && (tl[0].type == 'radio' || tl[0].type == 'checkbox'))
// 			for( var i = 0; i < tl.length; i++ )
// 				if( tl[i].checked ) {
// 					value = tl[i].value;
// 					break;
// 				}

// 		value = value ? value : "";
// 	} else if (!t.value) {
// 		value = "";
// 	} else {
// 		value = t.value;

// 		if (t.type == "checkbox") {
// 			value = t.checked ? value : "";
// 		}
// 	}

// 	return (value == ref)
// }

// function cbi_d_check(deps) {
// 	var reverse;
// 	var def = false;
// 	for (var i=0; i<deps.length; i++) {
// 		var istat = true;
// 		reverse = false;
// 		for (var j in deps[i]) {
// 			if (j == "!reverse") {
// 				reverse = true;
// 			} else if (j == "!default") {
// 				def = true;
// 				istat = false;
// 			} else {
// 				istat = (istat && cbi_d_checkvalue(j, deps[i][j]))
// 			}
// 		}
// 		if (istat) {
// 			return !reverse;
// 		}
// 	}
// 	return def;
// }

// function cbi_d_update() {
// 	var state = false;
// 	for (var i=0; i<cbi_d.length; i++) {
// 		var entry = cbi_d[i];
// 		var next  = document.getElementById(entry.next)
// 		var node  = document.getElementById(entry.id)
// 		var parent = document.getElementById(entry.parent)

// 		if (node && node.parentNode && !cbi_d_check(entry.deps)) {
// 			node.parentNode.removeChild(node);
// 			state = true;
// 			if( entry.parent )
// 				cbi_c[entry.parent]--;
// 		} else if ((!node || !node.parentNode) && cbi_d_check(entry.deps)) {
// 			if (!next) {
// 				parent.appendChild(entry.node);
// 			} else {
// 				next.parentNode.insertBefore(entry.node, next);
// 			}
// 			state = true;
// 			if( entry.parent )
// 				cbi_c[entry.parent]++;
// 		}
// 	}

// 	if (entry && entry.parent) {
// 		if (!cbi_t_update())
// 			cbi_tag_last(parent);
// 	}

// 	if (state) {
// 		cbi_d_update();
// 	}
// }

// function cbi_t_add(section, tab) {
// 	var t = document.getElementById('tab.' + section + '.' + tab);
// 	var c = document.getElementById('container.' + section + '.' + tab);

// 	if( t && c ) {
// 		cbi_t[section] = (cbi_t[section] || [ ]);
// 		cbi_t[section][tab] = { 'tab': t, 'container': c, 'cid': c.id };
// 	}
// }

// function cbi_t_switch(section, tab) {
// 	if( cbi_t[section] && cbi_t[section][tab] ) {
// 		var o = cbi_t[section][tab];
// 		var h = document.getElementById('tab.' + section);
// 		for( var tid in cbi_t[section] ) {
// 			var o2 = cbi_t[section][tid];
// 			if( o.tab.id != o2.tab.id ) {
// 				o2.tab.className = o2.tab.className.replace(/(^| )cbi-tab( |$)/, " cbi-tab-disabled ");
// 				o2.container.style.display = 'none';
// 			}
// 			else {
// 				if(h) h.value = tab;
// 				o2.tab.className = o2.tab.className.replace(/(^| )cbi-tab-disabled( |$)/, " cbi-tab ");
// 				o2.container.style.display = 'block';
// 			}
// 		}
// 	}
// 	return false
// }
// function cbi_validate_field(cbid, optional, type)
// {
// 	var field = (typeof cbid == "string") ? document.getElementById(cbid) : cbid;
// 	var vstack; try { vstack = cbi_validate_compile(type); } catch(e) { };

// 	if (field && vstack && typeof vstack[0] == "function")
// 	{
// 		var validator = function()
// 		{
// 			// is not detached
// 			if( field.form )
// 			{
// 				field.className = field.className.replace(/ cbi-input-invalid/g, '');

// 				// validate value
// 				var value = (field.options && field.options.selectedIndex > -1)
// 					? field.options[field.options.selectedIndex].value : field.value;

// 				if (!(((value.length == 0) && optional) || vstack[0].apply(value, vstack[1])))
// 				{
// 					// invalid
// 					field.className += ' cbi-input-invalid';
// 					return false;
// 				}
// 			}

// 			return true;
// 		};

// 		if( ! field.form.cbi_validators )
// 			field.form.cbi_validators = [ ];

// 		field.form.cbi_validators.push(validator);

// 		cbi_bind(field, "blur",  validator);
// 		cbi_bind(field, "keyup", validator);

// 		if (field.nodeName == 'SELECT')
// 		{
// 			cbi_bind(field, "change", validator);
// 			cbi_bind(field, "click",  validator);
// 		}

// 		field.setAttribute("cbi_validate", validator);
// 		field.setAttribute("cbi_datatype", type);
// 		field.setAttribute("cbi_optional", (!!optional).toString());

// 		validator();

// 		var fcbox = document.getElementById('cbi.combobox.' + field.id);
// 		if (fcbox)
// 			cbi_validate_field(fcbox, optional, type);
// 	}
// }
// function cbi_row_swap(elem, up, store)
// {
// 	var tr = elem.parentNode;
// 	while (tr && tr.nodeName.toLowerCase() != 'tr')
// 		tr = tr.parentNode;

// 	if (!tr)
// 		return false;

// 	var table = tr.parentNode;
// 	while (table && table.nodeName.toLowerCase() != 'table')
// 		table = table.parentNode;

// 	if (!table)
// 		return false;

// 	var s = up ? 3 : 2;
// 	var e = up ? table.rows.length : table.rows.length - 1;

// 	for (var idx = s; idx < e; idx++)
// 	{
// 		if (table.rows[idx] == tr)
// 		{
// 			if (up)
// 				tr.parentNode.insertBefore(table.rows[idx], table.rows[idx-1]);
// 			else
// 				tr.parentNode.insertBefore(table.rows[idx+1], table.rows[idx]);

// 			break;
// 		}
// 	}

// 	var ids = [ ];
// 	for (idx = 2; idx < table.rows.length; idx++)
// 	{
// 		table.rows[idx].className = table.rows[idx].className.replace(
// 			/cbi-rowstyle-[12]/, 'cbi-rowstyle-' + (1 + (idx % 2))
// 		);

// 		if (table.rows[idx].id && table.rows[idx].id.match(/-([^\-]+)$/) )
// 			ids.push(RegExp.$1);
// 	}

// 	var input = document.getElementById(store);
// 	if (input)
// 		input.value = ids.join(' ');

// 	return false;
// }

// function cbi_bind(obj, type, callback, mode) {
// 	if (!obj.addEventListener) {
// 		obj.attachEvent('on' + type,
// 			function(){
// 				var e = window.event;

// 				if (!e.target && e.srcElement)
// 					e.target = e.srcElement;

// 				return !!callback(e);
// 			}
// 		);
// 	} else {
// 		obj.addEventListener(type, callback, !!mode);
// 	}
// 	return obj;
// }

// function cbi_combobox(id, values, def, man) {
// 	var selid = "cbi.combobox." + id;
// 	if (document.getElementById(selid)) {
// 		return
// 	}

// 	var obj = document.getElementById(id)
// 	var sel = document.createElement("select");
// 		sel.id = selid;
// 		sel.className = obj.className.replace(/cbi-input-text/, 'cbi-input-select');

// 	if (obj.nextSibling) {
// 		obj.parentNode.insertBefore(sel, obj.nextSibling);
// 	} else {
// 		obj.parentNode.appendChild(sel);
// 	}

// 	var dt = obj.getAttribute('cbi_datatype');
// 	var op = obj.getAttribute('cbi_optional');

// 	if (dt)
// 		cbi_validate_field(sel, op == 'true', dt);

// 	if (!values[obj.value]) {
// 		if (obj.value == "") {
// 			var optdef = document.createElement("option");
// 			optdef.value = "";
// 			optdef.appendChild(document.createTextNode(def));
// 			sel.appendChild(optdef);
// 		} else {
// 			var opt = document.createElement("option");
// 			opt.value = obj.value;
// 			opt.selected = "selected";
// 			opt.appendChild(document.createTextNode(obj.value));
// 			sel.appendChild(opt);
// 		}
// 	}

// 	for (var i in values) {
// 		var opt = document.createElement("option");
// 		opt.value = i;

// 		if (obj.value == i) {
// 			opt.selected = "selected";
// 		}

// 		opt.appendChild(document.createTextNode(values[i]));
// 		sel.appendChild(opt);
// 	}

// 	var optman = document.createElement("option");
// 	optman.value = "";
// 	optman.appendChild(document.createTextNode(man));
// 	sel.appendChild(optman);

// 	obj.style.display = "none";

// 	cbi_bind(sel, "change", function() {
// 		if (sel.selectedIndex == sel.options.length - 1) {
// 			obj.style.display = "inline";
// 			sel.parentNode.removeChild(sel);
// 			obj.focus();
// 		} else {
// 			obj.value = sel.options[sel.selectedIndex].value;
// 		}

// 		try {
// 			cbi_d_update();
// 		} catch (e) {
// 			//Do nothing
// 		}
// 	})

// 	// Retrigger validation in select
// 	sel.focus();
// 	sel.blur();
// }

// function cbi_combobox_init(id, values, def, man) {
// 	var obj = document.getElementById(id);
// 	cbi_bind(obj, "blur", function() {
// 		cbi_combobox(id, values, def, man)
// 	});
// 	cbi_combobox(id, values, def, man);
// }


// String.format = function(str)
// {
//     var args = arguments, re = new RegExp("%([1-" + args.length + "])", "g");
//     return String(str).replace(
//         re,
//         function($1, $2)
// 	{
//             return args[$2];
//         }
//     );
// }

 
